searchNodes=[{"type":"module","title":"BSON","doc":"Functions for encoding and decoding BSON documents.","ref":"BSON.html"},{"type":"function","title":"BSON.decode/1","doc":"Decode iodata to a BSON document.","ref":"BSON.html#decode/1"},{"type":"function","title":"BSON.encode/1","doc":"Encode a BSON document to iodata .","ref":"BSON.html#encode/1"},{"type":"type","title":"BSON.document/0","doc":"","ref":"BSON.html#t:document/0"},{"type":"type","title":"BSON.t/0","doc":"","ref":"BSON.html#t:t/0"},{"type":"module","title":"BSON.Binary","doc":"Represents BSON binary type","ref":"BSON.Binary.html"},{"type":"type","title":"BSON.Binary.t/0","doc":"","ref":"BSON.Binary.html#t:t/0"},{"type":"module","title":"BSON.Decimal128","doc":"see https://en.wikipedia.org/wiki/Decimal128_floating-point_format","ref":"BSON.Decimal128.html"},{"type":"function","title":"BSON.Decimal128.decode/1","doc":"","ref":"BSON.Decimal128.html#decode/1"},{"type":"function","title":"BSON.Decimal128.encode/1","doc":"s 11110 xx...x ±infinity s 11111 0x...x a quiet NaN s 11111 1x...x a signalling NaN","ref":"BSON.Decimal128.html#encode/1"},{"type":"module","title":"BSON.JavaScript","doc":"Represents BSON JavaScript (with and without scope) types","ref":"BSON.JavaScript.html"},{"type":"type","title":"BSON.JavaScript.t/0","doc":"","ref":"BSON.JavaScript.html#t:t/0"},{"type":"module","title":"BSON.LongNumber","doc":"Represents BSON long type","ref":"BSON.LongNumber.html"},{"type":"type","title":"BSON.LongNumber.t/0","doc":"","ref":"BSON.LongNumber.html#t:t/0"},{"type":"module","title":"BSON.ObjectId","doc":"Represents BSON ObjectId type","ref":"BSON.ObjectId.html"},{"type":"function","title":"BSON.ObjectId.decode/1","doc":"Converts string representation of ObjectId to a BSON.ObjectId struct Examples { :ok , id } &lt;- BSON.ObjectId . decode ( bson_id )","ref":"BSON.ObjectId.html#decode/1"},{"type":"function","title":"BSON.ObjectId.decode!/1","doc":"Converts string representation of ObjectId to a BSON.ObjectId struct","ref":"BSON.ObjectId.html#decode!/1"},{"type":"function","title":"BSON.ObjectId.encode/1","doc":"Converts BSON.ObjectId struct to a string representation Examples { :ok , bson_id } &lt;- BSON.ObjectId . encode ( id )","ref":"BSON.ObjectId.html#encode/1"},{"type":"function","title":"BSON.ObjectId.encode!/1","doc":"Converts BSON.ObjectId struct to a string representation","ref":"BSON.ObjectId.html#encode!/1"},{"type":"function","title":"BSON.ObjectId.new/4","doc":"Creates a new ObjectId from the consisting parts","ref":"BSON.ObjectId.html#new/4"},{"type":"type","title":"BSON.ObjectId.t/0","doc":"","ref":"BSON.ObjectId.html#t:t/0"},{"type":"module","title":"BSON.Regex","doc":"Represents BSON Regex type","ref":"BSON.Regex.html"},{"type":"type","title":"BSON.Regex.t/0","doc":"","ref":"BSON.Regex.html#t:t/0"},{"type":"module","title":"BSON.Timestamp","doc":"Represents BSON Timestamp type","ref":"BSON.Timestamp.html"},{"type":"function","title":"BSON.Timestamp.is_after/2","doc":"","ref":"BSON.Timestamp.html#is_after/2"},{"type":"function","title":"BSON.Timestamp.is_before/2","doc":"","ref":"BSON.Timestamp.html#is_before/2"},{"type":"type","title":"BSON.Timestamp.t/0","doc":"","ref":"BSON.Timestamp.html#t:t/0"},{"type":"task","title":"Mix.Tasks.Mongo","doc":"Migrations are used to modify your database collection over time. This module provides some helpers for migrating the database, allowing developers to use Elixir to alter their storage in a way that is database independent. Migrations typically provide two operations: up and down, allowing us to migrate the database forward or roll it back in case of errors. In order to manage migrations, the driver creates a collection called migrations in the database, which stores all migrations that have already been executed. You can configure the name of this collection with the :collection configuration option. Creating your first migration Migrations are defined inside the &quot;priv/mongo/migrations&quot;. You can change the path using the configuration key :path . Each file in the migrations directory has the following structure: NUMBER_NAME.exs The NUMBER is a unique number that identifies the migration. It is usually the timestamp of when the migration was created. The NAME must also be unique and it quickly identifies what the migration does. For example, if you need to track the &quot;weather&quot; in your system, you can start a new file at &quot;priv/mongo/migrations/20190417140000_add_weather_index.exs&quot; that will have the following contents: defmodule Mongo.Migrations.AddWeatherIndex do def up ( ) do indexes = [ [ key : [ files_id : 1 , n : 1 ] , name : &quot;files_n_index&quot; , unique : true ] ] Mongo . create_indexes ( :mongo , &quot;weather&quot; , indexes ) end def down ( ) do Mongo . drop_index ( :mongo , &quot;weather&quot; , &quot;files_n_index&quot; ) end end The up/0 function is responsible to migrate your database forward. The down/0 function is executed whenever you want to rollback. The down/0 function must always do the opposite of up/0. Inside those functions, we invoke the API defined in this module, you will find conveniences for managing collections, indexes, as well as running custom MongoDB commands. To run a migration, we generally use Mix tasks. For example, you can run the migration above by going to the root of your project and typing: $ mix mongo . migrate You can also roll it back by calling: $ mix mongo . drop In practice, we don't create migration files by hand either, we typically use mix mongo.gen.migration to generate the file with the proper timestamp and then we just fill in its contents: $ mix mongo . gen . migration add_weather_index Configuration config :mongodb_driver , migration : [ path : &quot;migrations&quot; , otp_app : :mongodb_driver , topology : :mongo , collection : &quot;migrations&quot; ] The following migration configuration options are available: :collection - Version numbers of migrations will be saved in a collection named migrations by default. You can configure the name of the collection via: config :mongodb_driver, :migration, collection: &quot;my_migrations&quot; :path - the priv sub-directory for migrations. :path defaults to &quot;migrations&quot; and migrations should be placed at &quot;priv/mongo/migrations&quot; :otp_app - the name of the otp_app to resolve the priv folder, defaults to :mongodb_driver. In most cases you use your application name. :topology - the topology for running the migrations, :topology defaults to :mongo","ref":"Mix.Tasks.Mongo.html"},{"type":"task","title":"Mix.Tasks.Mongo.Drop","doc":"Drop the migrations when calling mix mongo.drop","ref":"Mix.Tasks.Mongo.Drop.html"},{"type":"task","title":"Mix.Tasks.Mongo.Migrate","doc":"Runs the migrations when calling mix mongo.migrate","ref":"Mix.Tasks.Mongo.Migrate.html"},{"type":"task","title":"Mix.Tasks.Mongo.Reset","doc":"Resets the database when calling mix mongo.reset","ref":"Mix.Tasks.Mongo.Reset.html"},{"type":"task","title":"Mix.Tasks.Mongo.Unlock","doc":"Unlocks the migration lock","ref":"Mix.Tasks.Mongo.Unlock.html"},{"type":"module","title":"Mongo","doc":"The main entry point for doing queries. All functions take a topology to run the query on. Generic options All operations take these options. :timeout - The maximum time that the caller is allowed the to hold the connection’s state (ignored when using a run/transaction connection, default: 15_000 ) :checkout_timeout - The maximum time for checking out a new session and connection (default: 60_000 ). When the connection pool exhausted then the function call times out after :checkout_timeout. :pool - The pooling behaviour module to use, this option is required unless the default DBConnection pool is used :pool_timeout - The maximum time to wait for a reply when making a synchronous call to the pool (default: 5_000 ) :queue - Whether to block waiting in an internal queue for the connection's state (boolean, default: true ) :log - A function to log information about a call, either a 1-arity fun, {module, function, args} with DBConnection.LogEntry.t prepended to args or nil . See DBConnection.LogEntry (default: nil ) :database - the database to run the operation on :connect_timeout - maximum timeout for connect (default: 5_000 ) Read options All read operations that returns a cursor take the following options for controlling the behaviour of the cursor. :batch_size - Number of documents to fetch in each batch :limit - Maximum number of documents to fetch with the cursor :read_preference - specifies the rules for selecting a server to query Write options All write operations take the following options for controlling the write concern. :w - The number of servers to replicate to before returning from write operators, a 0 value will return immediately, :majority will wait until the operation propagates to a majority of members in the replica set (Default: 1) :j If true, the write operation will only return after it has been committed to journal - (Default: false) :wtimeout - If the write concern is not satisfied in the specified interval, the operation returns an error","ref":"Mongo.html"},{"type":"function","title":"Mongo.abort_transaction/1","doc":"","ref":"Mongo.html#abort_transaction/1"},{"type":"function","title":"Mongo.abort_transaction/2","doc":"","ref":"Mongo.html#abort_transaction/2"},{"type":"function","title":"Mongo.admin_command/2","doc":"Executes an admin command against the admin database using always the primary. Retryable writes are disabled. Example iex&gt; cmd = [ configureFailPoint : &quot;failCommand&quot; , mode : &quot;alwaysOn&quot; , data : [ errorCode : 6 , failCommands : [ &quot;commitTransaction&quot; ] , errorLabels : [ &quot;TransientTransactionError&quot; ] ] ] iex&gt; {:ok, _doc} = Mongo.admin_command(top, cmd)","ref":"Mongo.html#admin_command/2"},{"type":"function","title":"Mongo.aggregate/4","doc":"Performs aggregation operation using the aggregation pipeline. For all options see Options","ref":"Mongo.html#aggregate/4"},{"type":"function","title":"Mongo.causal_consistency/3","doc":"Convenient function to execute write and read operation with a causal consistency session. With causally consistent sessions, MongoDB executes causal operations in an order that respect their causal relationships, and clients observe results that are consistent with the causal relationships. Example { :ok , 0 } = Mongo . causal_consistency ( top , fn -&gt; Mongo . delete_many ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , w : :majority ) Mongo . count ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , read_concern : %{ level : :majority } ) end ) The function creates a causal consistency session and stores it in the process dictionary under the key :session . But you need to specify the write and read concerns for each operation to :majority","ref":"Mongo.html#causal_consistency/3"},{"type":"function","title":"Mongo.child_spec/1","doc":"","ref":"Mongo.html#child_spec/1"},{"type":"function","title":"Mongo.command/3","doc":"Issue a database command. If the command has parameters use a keyword list for the document because the &quot;command key&quot; has to be the first in the document.","ref":"Mongo.html#command/3"},{"type":"function","title":"Mongo.command!/3","doc":"Similar to command/3 but unwraps the result and raises on error.","ref":"Mongo.html#command!/3"},{"type":"function","title":"Mongo.count_documents/4","doc":"Returns the count of documents that would match a find/4 query. Options :limit - Maximum number of documents to fetch with the cursor :skip - Number of documents to skip before returning the first","ref":"Mongo.html#count_documents/4"},{"type":"function","title":"Mongo.count_documents!/4","doc":"Similar to count_documents/4 but unwraps the result and raises on error.","ref":"Mongo.html#count_documents!/4"},{"type":"function","title":"Mongo.create/3","doc":"Explicitly creates a collection or view.","ref":"Mongo.html#create/3"},{"type":"function","title":"Mongo.create_indexes/4","doc":"Convenient function to creates new indexes in the collection coll . The indexes parameter is a list with all options for creating indexes in the MongoDB. See options about the details of each parameter.","ref":"Mongo.html#create_indexes/4"},{"type":"function","title":"Mongo.delete_many/4","doc":"Remove all documents matching the filter from the collection.","ref":"Mongo.html#delete_many/4"},{"type":"function","title":"Mongo.delete_many!/4","doc":"Similar to delete_many/4 but unwraps the result and raises on error.","ref":"Mongo.html#delete_many!/4"},{"type":"function","title":"Mongo.delete_one/4","doc":"Remove a document matching the filter from the collection.","ref":"Mongo.html#delete_one/4"},{"type":"function","title":"Mongo.delete_one!/4","doc":"Similar to delete_one/4 but unwraps the result and raises on error.","ref":"Mongo.html#delete_one!/4"},{"type":"function","title":"Mongo.distinct/5","doc":"Finds the distinct values for a specified field across a collection. Options :max_time - Specifies a time limit in milliseconds :collation - Optionally specifies a collation to use in MongoDB 3.4 and","ref":"Mongo.html#distinct/5"},{"type":"function","title":"Mongo.distinct!/5","doc":"Similar to distinct/5 but unwraps the result and raises on error.","ref":"Mongo.html#distinct!/5"},{"type":"function","title":"Mongo.drop_collection/3","doc":"Convenient function that drops the collection coll .","ref":"Mongo.html#drop_collection/3"},{"type":"function","title":"Mongo.drop_database/3","doc":"Convenient function that drops the database name .","ref":"Mongo.html#drop_database/3"},{"type":"function","title":"Mongo.drop_index/4","doc":"Convenient function that drops the index name in the collection coll .","ref":"Mongo.html#drop_index/4"},{"type":"function","title":"Mongo.estimated_document_count/3","doc":"Estimate the number of documents in a collection using collection metadata.","ref":"Mongo.html#estimated_document_count/3"},{"type":"function","title":"Mongo.estimated_document_count!/3","doc":"Similar to estimated_document_count/3 but unwraps the result and raises on error.","ref":"Mongo.html#estimated_document_count!/3"},{"type":"function","title":"Mongo.exec_hello/2","doc":"","ref":"Mongo.html#exec_hello/2"},{"type":"function","title":"Mongo.exec_hello/3","doc":"","ref":"Mongo.html#exec_hello/3"},{"type":"function","title":"Mongo.exec_more_to_come/2","doc":"","ref":"Mongo.html#exec_more_to_come/2"},{"type":"function","title":"Mongo.find/4","doc":"Selects documents in a collection and returns a cursor for the selected documents. For all options see Options Use the underscore style, for example to set the option singleBatch use single_batch . Another example: Mongo . find ( top , &quot;jobs&quot; , %{ } , batch_size : 2 )","ref":"Mongo.html#find/4"},{"type":"function","title":"Mongo.find_one/4","doc":"Selects a single document in a collection and returns either a document or nil. If multiple documents satisfy the query, this method returns the first document according to the natural order which reflects the order of documents on the disk. For all options see Options Use the underscore style, for example to set the option readConcern use read_concern . Another example: Mongo . find_one ( top , &quot;jobs&quot; , %{ } , read_concern : %{ level : &quot;local&quot; } )","ref":"Mongo.html#find_one/4"},{"type":"function","title":"Mongo.find_one_and_delete/4","doc":"Finds a document and deletes it. Options :max_time - The maximum amount of time to allow the query to run (in MS) :projection - Limits the fields to return for all matching documents. :sort - Determines which document the operation modifies if the query selects multiple documents. :collation - Optionally specifies a collation to use in MongoDB 3.4 and higher.","ref":"Mongo.html#find_one_and_delete/4"},{"type":"function","title":"Mongo.find_one_and_replace/5","doc":"Finds a document and replaces it. Options :bypass_document_validation - Allows the write to opt-out of document level validation :max_time - The maximum amount of time to allow the query to run (in MS) :projection - Limits the fields to return for all matching documents. :return_document - Returns the replaced or inserted document rather than the original. Values are :before or :after. (default is :before) :sort - Determines which document the operation modifies if the query selects multiple documents. :upsert - Create a document if no document matches the query or updates the document. :collation - Optionally specifies a collation to use in MongoDB 3.4 and higher.","ref":"Mongo.html#find_one_and_replace/5"},{"type":"function","title":"Mongo.find_one_and_update/5","doc":"Finds a document and updates it (using atomic modifiers). Options :bypass_document_validation - Allows the write to opt-out of document level validation :max_time - The maximum amount of time to allow the query to run (in MS) :projection - Limits the fields to return for all matching documents. :return_document - Returns the replaced or inserted document rather than the original. Values are :before or :after. (default is :before) :sort - Determines which document the operation modifies if the query selects multiple documents. :upsert - Create a document if no document matches the query or updates the document. :collation - Optionally specifies a collation to use in MongoDB 3.4 and","ref":"Mongo.html#find_one_and_update/5"},{"type":"function","title":"Mongo.get_session/1","doc":"","ref":"Mongo.html#get_session/1"},{"type":"function","title":"Mongo.insert_many/4","doc":"Insert multiple documents into the collection. If any of the documents is missing the _id field or it is nil , an ObjectId will be generated, and insertd into the document. Ids of all documents will be returned in the result struct. Options For more information about options see Options Examples Mongo . insert_many ( pid , &quot;users&quot; , [ %{ first_name : &quot;John&quot; , last_name : &quot;Smith&quot; } , %{ first_name : &quot;Jane&quot; , last_name : &quot;Doe&quot; } ] )","ref":"Mongo.html#insert_many/4"},{"type":"function","title":"Mongo.insert_many!/4","doc":"Similar to insert_many/4 but unwraps the result and raises on error.","ref":"Mongo.html#insert_many!/4"},{"type":"function","title":"Mongo.insert_one/4","doc":"Insert a single document into the collection. If the document is missing the _id field or it is nil , an ObjectId will be generated, inserted into the document, and returned in the result struct. Examples Mongo . insert_one ( pid , &quot;users&quot; , %{ first_name : &quot;John&quot; , last_name : &quot;Smith&quot; } ) { :ok , session } = Session . start_session ( pid ) Session . start_transaction ( session ) Mongo . insert_one ( pid , &quot;users&quot; , %{ first_name : &quot;John&quot; , last_name : &quot;Smith&quot; } , session : session ) Session . commit_transaction ( session ) Session . end_session ( pid )","ref":"Mongo.html#insert_one/4"},{"type":"function","title":"Mongo.insert_one!/4","doc":"Similar to insert_one/4 but unwraps the result and raises on error.","ref":"Mongo.html#insert_one!/4"},{"type":"function","title":"Mongo.issue_command/4","doc":"This function is very fundamental.","ref":"Mongo.html#issue_command/4"},{"type":"function","title":"Mongo.limits/1","doc":"Returns the limits of the database. Example { :ok , top } = Mongo . start_link ( ... ) Mongo . limits ( top ) { :ok , %{ compression : nil , logical_session_timeout : 30 , max_bson_object_size : 16777216 , max_message_size_bytes : 48000000 , max_wire_version : 8 , max_write_batch_size : 100000 , read_only : false } }","ref":"Mongo.html#limits/1"},{"type":"function","title":"Mongo.list_index_names/3","doc":"Convenient function that returns a cursor with the names of the indexes.","ref":"Mongo.html#list_index_names/3"},{"type":"function","title":"Mongo.list_indexes/3","doc":"Returns a cursor to enumerate all indexes","ref":"Mongo.html#list_indexes/3"},{"type":"function","title":"Mongo.object_id/0","doc":"Generates a new BSON.ObjectId .","ref":"Mongo.html#object_id/0"},{"type":"function","title":"Mongo.ping/1","doc":"Sends a ping command to the server.","ref":"Mongo.html#ping/1"},{"type":"function","title":"Mongo.rename_collection/4","doc":"Changes the name of an existing collection. Specify collection names to rename_collection in the form of a complete namespace (&lt;database&gt;.&lt;collection&gt;).","ref":"Mongo.html#rename_collection/4"},{"type":"function","title":"Mongo.replace_one/5","doc":"Replace a single document matching the filter with the new document. Options :upsert - if set to true creates a new document when no document matches the filter (default: false )","ref":"Mongo.html#replace_one/5"},{"type":"function","title":"Mongo.replace_one!/5","doc":"Similar to replace_one/5 but unwraps the result and raises on error.","ref":"Mongo.html#replace_one!/5"},{"type":"function","title":"Mongo.retryable_reads/1","doc":"In case of retryable reads are enabled, the keyword :read_counter is added with the value of 1. In other cases like :retryable_reads is false or nil :session is nil :read_counter is nil the opts is unchanged Example iex&gt; Mongo.retryable_reads([retryable_reads: true]) [retryable_reads: true, read_counter: 1]","ref":"Mongo.html#retryable_reads/1"},{"type":"function","title":"Mongo.retryable_writes/2","doc":"In case of retryable writes are enabled, the keyword :write_counter is added with the value of 1. In other cases like :retryable_writes is false or nil :session is nil :write_counter is nil the opts is unchanged Example iex&gt; Mongo.retryable_writes([retryable_writes: true], true) [retryable_writes: true, write_counter: 1]","ref":"Mongo.html#retryable_writes/2"},{"type":"function","title":"Mongo.show_collections/2","doc":"Getting Collection Names","ref":"Mongo.html#show_collections/2"},{"type":"function","title":"Mongo.start_link/1","doc":"Start and link to a database connection process. Options :database - The database to use (required) :hostname - The host to connect to (require) :port - The port to connect to your server (default: 27017) :url - A mongo connection url. Can be used in place of :hostname and :database (optional) :socket_dir - Connect to MongoDB via UNIX sockets in the given directory. The socket name is derived based on the port. This is the preferred method for configuring sockets and it takes precedence over the hostname. If you are connecting to a socket outside of the MongoDB convection, use :socket instead. :socket - Connect to MongoDB via UNIX sockets in the given path. This option takes precedence over :hostname and :socket_dir . :database (optional) :seeds - A list of host names in the cluster. Can be used in place of :hostname (optional) :username - The User to connect with (optional) :password - The password to connect with (optional) :auth_source - The database to authenticate against :appname - The name of the application used the driver for the MongoDB-Handshake :set_name - The name of the replica set to connect to (required if connecting to a replica set) :type - a hint of the topology type. See initial_type/0 for valid values (default: :unknown ) :idle - The idle strategy, :passive to avoid checkin when idle and :active to checking when idle (default: :passive ) :idle_timeout - The idle timeout to ping the database (default: 1_000 ) :connect_timeout - The maximum timeout for the initial connection (default: 5_000 ) :backoff_min - The minimum backoff interval (default: 1_000 ) :backoff_max - The maximum backoff interval (default: 30_000 ) :backoff_type - The backoff strategy, :stop for no backoff and to stop, :exp of exponential, :rand for random and :ran_exp for random exponential (default: :rand_exp ) :after_connect - A function to run on connect use run/3 . Either a 1-arity fun, {module, function, args} with DBConnection.t , prepended to args or nil (default: nil ) :auth_mechanism - options for the mongo authentication mechanism, currently only supports :x509 atom as a value :ssl - Set to true if ssl should be used (default: false ) :ssl_opts - A list of ssl options, see the ssl docs Error Reasons :single_topology_multiple_hosts - A topology of :single was set but multiple hosts were given :set_name_bad_topology - A :set_name was given but the topology was set to something other than :replica_set_no_primary or :single","ref":"Mongo.html#start_link/1"},{"type":"function","title":"Mongo.timestamp/1","doc":"Converts the DataTime to a MongoDB timestamp.","ref":"Mongo.html#timestamp/1"},{"type":"function","title":"Mongo.transaction/3","doc":"Convenient function for running multiple write commands in a transaction. In case of TransientTransactionError or UnknownTransactionCommitResult the function will retry the whole transaction or the commit of the transaction. You can specify a timeout ( :transaction_retry_timeout_s ) to limit the time of repeating. The default value is 120 seconds. If you don't wait so long, you call with_transaction with the option transaction_retry_timeout_s: 10 . In this case after 10 seconds of retrying, the function will return an error. Example { :ok , ids } = Mongo . transaction ( top , fn -&gt; { :ok , % InsertOneResult { :inserted_id =&gt; id1 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id2 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id3 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } ) { :ok , [ id1 , id2 , id3 ] } end , transaction_retry_timeout_s : 10 ) If transaction/3 is called inside another transaction, the function is simply executed, without wrapping the new transaction call in any way. If there is an error in the inner transaction and the error is rescued, or the inner transaction is aborted (abort_transaction/1), the whole outer transaction is aborted, guaranteeing nothing will be committed.","ref":"Mongo.html#transaction/3"},{"type":"function","title":"Mongo.update_many/5","doc":"Update all documents matching the filter. Uses MongoDB update operators to specify the updates. For more information and all options please refer to the MongoDB documentation","ref":"Mongo.html#update_many/5"},{"type":"function","title":"Mongo.update_many!/5","doc":"Similar to update_many/5 but unwraps the result and raises on error.","ref":"Mongo.html#update_many!/5"},{"type":"function","title":"Mongo.update_one/5","doc":"Update a single document matching the filter. Uses MongoDB update operators to specify the updates. For more information please refer to the MongoDB documentation Example: Mongo . update_one ( MongoPool , &quot;my_test_collection&quot; , %{ &quot;filter_field&quot; : &quot;filter_value&quot; } , %{ &quot;$set&quot; : %{ &quot;modified_field&quot; : &quot;new_value&quot; } } ) Options :upsert - if set to true creates a new document when no document matches the filter (default: false )","ref":"Mongo.html#update_one/5"},{"type":"function","title":"Mongo.update_one!/5","doc":"Similar to update_one/5 but unwraps the result and raises on error.","ref":"Mongo.html#update_one!/5"},{"type":"function","title":"Mongo.uuid/0","doc":"Creates a new UUID.","ref":"Mongo.html#uuid/0"},{"type":"function","title":"Mongo.uuid/1","doc":"Converts the binary to UUID Example iex&gt; Mongo . uuid ( &quot;848e90e9-5750-4e0a-ab73-66ac6b328242&quot; ) { :ok , # BSON.UUID &lt; 848 e90e9 - 5750 - 4 e0a - ab73 - 66 ac6b328242 &gt; } iex&gt; Mongo . uuid ( &quot;848e90e9-5750-4e0a-ab73-66ac6b328242x&quot; ) { :error , % ArgumentError { message : &quot;invalid UUID string&quot; } } iex&gt; Mongo . uuid ( &quot;848e90e9-5750-4e0a-ab73-66-c6b328242&quot; ) { :error , % ArgumentError { message : &quot;non-alphabet digit found: &quot; - &quot; (byte 45)&quot; } }","ref":"Mongo.html#uuid/1"},{"type":"function","title":"Mongo.uuid!/1","doc":"Similar to uuid/1 except it will unwrap the error tuple and raise in case of errors. Example iex&gt; Mongo . uuid! ( &quot;848e90e9-5750-4e0a-ab73-66ac6b328242&quot; ) # BSON.UUID &lt; 848 e90e9 - 5750 - 4 e0a - ab73 - 66 ac6b328242 &gt; iex&gt; Mongo . uuid! ( &quot;848e90e9-5750-4e0a-ab73-66ac6b328242x&quot; ) ** (ArgumentError) invalid UUID string ( mongodb_driver 0.6 . 4 ) lib / mongo . ex : 205 : Mongo . uuid! / 1","ref":"Mongo.html#uuid!/1"},{"type":"function","title":"Mongo.watch_collection/5","doc":"Creates a change stream cursor on collections. on_resume_token is function that takes the new resume token, if it changed. Options :full_document - :max_time - Specifies a time limit in milliseconds. This option is used on getMore commands :batch_size - Specifies the number of maximum number of documents to return (default: 1) :resume_after - Specifies the logical starting point for the new change stream. :start_at_operation_time - The change stream will only provide changes that occurred at or after the specified timestamp (since 4.0) :start_after - Similar to resumeAfter , this option takes a resume token and starts a new change stream returning the first notification after the token. This will allow users to watch collections that have been dropped and recreated or newly renamed collections without missing any notifications. (since 4.0.7)","ref":"Mongo.html#watch_collection/5"},{"type":"function","title":"Mongo.watch_db/4","doc":"Creates a change stream cursor all collections of the database. on_resume_token is function that takes the new resume token, if it changed. Options :full_document - :max_time - Specifies a time limit in milliseconds. This option is used on getMore commands :batch_size - Specifies the number of maximum number of documents to return (default: 1) :resume_after - Specifies the logical starting point for the new change stream. :start_at_operation_time - The change stream will only provide changes that occurred at or after the specified timestamp (since 4.0) :start_after - Similar to resumeAfter , this option takes a resume token and starts a new change stream returning the first notification after the token. This will allow users to watch collections that have been dropped and recreated or newly renamed collections without missing any notifications. (since 4.0.7)","ref":"Mongo.html#watch_db/4"},{"type":"function","title":"Mongo.wire_version/1","doc":"Returns the wire version of the database Example { :ok , top } = Mongo . start_link ( ... ) Mongo . wire_version ( top ) { :ok , 8 }","ref":"Mongo.html#wire_version/1"},{"type":"type","title":"Mongo.collection/0","doc":"","ref":"Mongo.html#t:collection/0"},{"type":"type","title":"Mongo.conn/0","doc":"","ref":"Mongo.html#t:conn/0"},{"type":"type","title":"Mongo.cursor/0","doc":"","ref":"Mongo.html#t:cursor/0"},{"type":"type","title":"Mongo.initial_type/0","doc":"","ref":"Mongo.html#t:initial_type/0"},{"type":"type","title":"Mongo.result/1","doc":"","ref":"Mongo.html#t:result/1"},{"type":"type","title":"Mongo.result!/1","doc":"","ref":"Mongo.html#t:result!/1"},{"type":"module","title":"Mongo.BulkOps","doc":"This module defines bulk operation for insert, update and delete. A bulk operation is a tuple of two elements an atom, which specify the type :insert , :update and :delete a document or another tuple which contains all parameters of the operation. You use these function in streams: Example alias Mongo.UnorderedBulk alias Mongo.BulkOps Filestream ! ( &quot;large.csv&quot; ) |&gt; Stream . map ( &amp; String . trim ( &amp;1 ) ) |&gt; Stream . map ( &amp; String . split ( &amp;1 , &quot;,&quot; ) ) |&gt; Stream . map ( fn [ firstname | [ lastname | _ ] ] -&gt; %{ firstname : firstname , lastname : lastname } end ) |&gt; Stream . map ( fn doc -&gt; BulkOps . get_insert_one ( doc ) end ) |&gt; UnorderedBulk . write ( :mongo , &quot;bulk&quot; , 1_000 ) |&gt; Stream . run ( )","ref":"Mongo.BulkOps.html"},{"type":"function","title":"Mongo.BulkOps.get_delete_many/1","doc":"Returns an delete_many operation for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_delete_many ( %{ name : &quot;Waldo&quot; } ) { :delete , { %{ name : &quot;Waldo&quot; } , [ limit : 0 ] } }","ref":"Mongo.BulkOps.html#get_delete_many/1"},{"type":"function","title":"Mongo.BulkOps.get_delete_one/1","doc":"Returns an delete_one operation tuple for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_delete_one ( %{ name : &quot;Waldo&quot; } ) { :delete , { %{ name : &quot;Waldo&quot; } , [ limit : 1 ] } }","ref":"Mongo.BulkOps.html#get_delete_one/1"},{"type":"function","title":"Mongo.BulkOps.get_insert_one/1","doc":"Returns an insert_one operation tuple for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_insert_one ( %{ name : &quot;Waldo&quot; } ) { :insert , %{ name : &quot;Waldo&quot; } }","ref":"Mongo.BulkOps.html#get_insert_one/1"},{"type":"function","title":"Mongo.BulkOps.get_replace_one/3","doc":"Returns an replace_one operation for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_replace_one ( %{ name : &quot;Waldo&quot; } , %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } ) { :update , { %{ name : &quot;Waldo&quot; } , %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } , [ multi : false ] } }","ref":"Mongo.BulkOps.html#get_replace_one/3"},{"type":"function","title":"Mongo.BulkOps.get_update_many/3","doc":"Returns an update_many operation for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_update_many ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) { :update , { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : true ] } }","ref":"Mongo.BulkOps.html#get_update_many/3"},{"type":"function","title":"Mongo.BulkOps.get_update_one/3","doc":"Returns an update_one operation for appending to a bulk. Used to perform stream bulk writes. Example Mongo.BulkOps . get_update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) { :update , { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : false ] } }","ref":"Mongo.BulkOps.html#get_update_one/3"},{"type":"type","title":"Mongo.BulkOps.bulk_op/0","doc":"","ref":"Mongo.BulkOps.html#t:bulk_op/0"},{"type":"module","title":"Mongo.BulkWrite","doc":"The driver supports the so-called bulk writes ( Specification ): The motivation for bulk writes lies in the possibility of optimizing to group the same operations. The driver supports unordered and ordered bulk writes in-memory and stream bulk writes Unordered bulk writes Unordered bulk writes have the highest optimization factor. Here all operations can be divided into three groups (inserts, updates and deletes). The order of execution within a group does not matter. However, the groups are executed in the order: inserts, updates and deletes. The following example creates three records, changes them, and then deletes all records. After execution, the collection is unchanged. It's valid, because of the execution order: inserts updates deletes Example: alias Mongo.BulkWrite alias Mongo.UnorderedBulk bulk = &quot;bulk&quot; |&gt; UnorderedBulk . new ( ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Greta&quot; } ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Tom&quot; } ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Waldo&quot; } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Greta&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Tom&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) result = BulkWrite . write ( :mongo , bulk , w : 1 ) Ordered bulk writes Sometimes the order of execution is important for successive operations to yield a correct result. In this case, one uses ordered bulk writes. The following example would not work with unordered bulk writes because the order within the update operations is undefined. The update_many() will only work, if it is executed after the update_one() functions. bulk = &quot;bulk&quot; |&gt; OrderedBulk . new ( ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Greta&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Tom&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Waldo&quot; } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Greta&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Tom&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_many ( %{ kind : &quot;dog&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;cat&quot; } } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) result = BulkWrite . write ( :mongo , bulk , w : 1 ) Stream bulk writes The examples shown initially filled the bulk with a few operations and then the bulk is written to the database. This is all done in memory. For larger amounts of operations or imports of very long files, the main memory would be unnecessarily burdened. It could come to some resource problems. For such cases you could use streams. Unordered and ordered bulk writes can also be combined with Streams. You set the maximum size of the bulk. Once the number of bulk operations has been reached, it will be sent to the database. While streaming you can limit the memory consumption regarding the current task. In the following example we import 1.000.000 integers into the MongoDB using the stream api: We need to create an insert operation ( BulkOps.get_insert_one() ) for each number. Then we call the UnorderedBulk.stream function to import it. This function returns a stream function which accumulate all inserts operations until the limit 1000 is reached. In this case the operation group is written to MongoDB. Example 1 .. 1_000_000 |&gt; Stream . map ( fn i -&gt; BulkOps . get_insert_one ( %{ number : i } ) end ) |&gt; UnorderedBulk . write ( :mongo , &quot;bulk&quot; , 1_000 ) |&gt; Stream . run ( ) Benchmark The following benchmark compares multiple Mongo.insert_one() calls with a stream using unordered bulk writes. Both tests inserts documents into a replica set with w: 1 . Benchee . run ( %{ &quot;inserts&quot; =&gt; fn input -&gt; input |&gt; Enum . map ( fn i -&gt; %{ number : i } end ) |&gt; Enum . each ( fn doc -&gt; Mongo . insert_one! ( top , &quot;bulk_insert&quot; , doc ) end ) end , &quot;streams&quot; =&gt; fn input -&gt; input |&gt; Stream . map ( fn i -&gt; get_insert_one ( %{ number : i } ) end ) |&gt; Mongo.UnorderedBulk . write ( top , &quot;bulk&quot; , 1_0000 ) |&gt; Stream . run ( ) end , } , inputs : %{ &quot;Small&quot; =&gt; Enum . to_list ( 1 .. 10_000 ) , &quot;Medium&quot; =&gt; Enum . to_list ( 1 .. 100_000 ) , &quot;Bigger&quot; =&gt; Enum . to_list ( 1 .. 1_000_000 ) } ) Result: ##### With input Bigger ##### Name ips average deviation median 99 th % streams 0.0885 0.188 min ± 0.00 % 0.188 min 0.188 min inserts 0.00777 2.14 min ± 0.00 % 2.14 min 2.14 min Comparison : streams 0.0885 inserts 0.00777 - 11.39 x slower + 1.96 min ##### With input Medium ##### Name ips average deviation median 99 th % streams 1.00 1.00 s ± 8.98 % 0.99 s 1.12 s inserts 0.0764 13.09 s ± 0.00 % 13.09 s 13.09 s Comparison : streams 1.00 inserts 0.0764 - 13.12 x slower + 12.10 s ##### With input Small ##### Name ips average deviation median 99 th % streams 8.26 0.121 s ± 30.46 % 0.112 s 0.23 s inserts 0.75 1.34 s ± 7.15 % 1.29 s 1.48 s Comparison : streams 8.26 inserts 0.75 - 11.07 x slower + 1.22 s The result is, that using bulk writes is much faster (about 15x faster at all).","ref":"Mongo.BulkWrite.html"},{"type":"function","title":"Mongo.BulkWrite.write/3","doc":"Executes unordered and ordered bulk writes. Unordered bulk writes The operation are grouped (inserts, updates, deletes). The order of execution is: inserts updates deletes The execution order within the group is not preserved. Ordered bulk writes Sequences of the same operations are grouped and sent as one command. The order is preserved. If a group (inserts, updates or deletes) exceeds the limit maxWriteBatchSize it will be split into chunks. Everything is done in memory, so this use case is limited by memory. A better approach seems to use streaming bulk writes.","ref":"Mongo.BulkWrite.html#write/3"},{"type":"module","title":"Mongo.BulkWriteResult","doc":"The successful result struct of Mongo.BulkWrite.write . Its fields are: :acknowledged - Write-concern :matched_count - Number of matched documents :modified_count - Number of modified documents :inserted_count - Number of inserted documents :deleted_count - Number of deleted documents :upserted_count - Number of upserted documents :upserted_ids - If the operation was an upsert, the upserted ids :inserted_ids - If the operation was an insert, the inserted ids :errors - If the operation results in an error, the error is collected","ref":"Mongo.BulkWriteResult.html"},{"type":"function","title":"Mongo.BulkWriteResult.add/2","doc":"","ref":"Mongo.BulkWriteResult.html#add/2"},{"type":"function","title":"Mongo.BulkWriteResult.delete_result/2","doc":"","ref":"Mongo.BulkWriteResult.html#delete_result/2"},{"type":"function","title":"Mongo.BulkWriteResult.empty/0","doc":"","ref":"Mongo.BulkWriteResult.html#empty/0"},{"type":"function","title":"Mongo.BulkWriteResult.error/1","doc":"","ref":"Mongo.BulkWriteResult.html#error/1"},{"type":"function","title":"Mongo.BulkWriteResult.insert_result/3","doc":"","ref":"Mongo.BulkWriteResult.html#insert_result/3"},{"type":"function","title":"Mongo.BulkWriteResult.reduce/1","doc":"","ref":"Mongo.BulkWriteResult.html#reduce/1"},{"type":"function","title":"Mongo.BulkWriteResult.reduce/2","doc":"","ref":"Mongo.BulkWriteResult.html#reduce/2"},{"type":"function","title":"Mongo.BulkWriteResult.update_result/5","doc":"","ref":"Mongo.BulkWriteResult.html#update_result/5"},{"type":"type","title":"Mongo.BulkWriteResult.t/0","doc":"","ref":"Mongo.BulkWriteResult.html#t:t/0"},{"type":"module","title":"Mongo.Collection","doc":"This module provides some boilerplate code for a better support of structs while using the MongoDB driver: automatic load and dump function reflection functions type specification support for embedding one and many structs support for after load function support for before dump function support for id generation support for default values support for derived values When using the MongoDB driver only maps and keyword lists are used to represent documents. If you prefer to use structs instead of the maps to give the document a stronger meaning or to emphasize its importance, you have to create a defstruct and fill it from the map manually: defmodule Label do defstruct name : &quot;warning&quot; , color : &quot;red&quot; end iex&gt; label_map = Mongo . find_one ( :mongo , &quot;labels&quot; , %{ } ) %{ &quot;name&quot; =&gt; &quot;warning&quot; , &quot;color&quot; =&gt; &quot;red&quot; } iex&gt; label = % Label { name : label_map [ &quot;name&quot; ] , color : label_map [ &quot;color&quot; ] } We have defined a module Label as defstruct , then we get the first label document the collection labels . The function find_one returns a map. We convert the map manually and get the desired struct. If we want to save a new structure, we have to do the reverse. We convert the struct into a map: iex&gt; label = % Label { } iex&gt; label_map = %{ &quot;name&quot; =&gt; label . name , &quot;color&quot; =&gt; label . color } iex&gt; { :ok , _ } = Mongo . insert_one ( :mongo , &quot;labels&quot; , label_map ) Alternatively, you can also remove the __struct__ key from label . The MongoDB driver automatically converts the atom keys into strings. iex&gt; Map . drop ( label , [ :__struct__ ] ) %{ color : :red , name : &quot;warning&quot; } If you use nested structures, the work becomes a bit more complex. In this case, you have to use the inner structures convert manually, too. If you take a closer look at the necessary work, two basic functions can be derived: load Conversion of the map into a struct. dump Conversion of the struct into a map. This module provides the necessary macros to automate this boilerplate code. The above example can be rewritten as follows: defmodule Label do use Collection document do attribute :name , String . t ( ) , default : &quot;warning&quot; attribute :color , String . t ( ) , default : :red end end This results in the following module: defmodule Label do defstruct [ name : &quot;warning&quot; , color : &quot;red&quot; ] @type t ( ) :: % Label { String . t ( ) , String . t ( ) } def new ( ) ... def load ( map ) ... def dump ( % Label { } ) ... def __collection__ ( :attributes ) ... def __collection__ ( :types ) ... def __collection__ ( :collection ) ... def __collection__ ( :id ) ... end You can now create new structs with the default values and use the conversion functions between maps and structs: iex(1)&gt; x = Label . new ( ) % Label { color : :red , name : &quot;warning&quot; } iex(2)&gt; m = Label . dump ( x ) %{ color : :red , name : &quot;warning&quot; } iex(3)&gt; Label . load ( m , true ) % Label { color : :red , name : &quot;warning&quot; } The load/2 function distinguishes between keys of type binaries load(map, false) and keys of type atoms load(map, true) . The default is load(map, false) : iex(1)&gt; m = %{ &quot;color&quot; =&gt; :red , &quot;name&quot; =&gt; &quot;warning&quot; } iex(2)&gt; Label . load ( m ) % Label { color : :red , name : &quot;warning&quot; } If you would now expect atoms as keys, the result of the conversion is not correct in this case: iex(3)&gt; Label . load ( m , true ) % Label { color : nil , name : nil } The background is that MongoDB always returns binaries as keys and structs use atoms as keys. Dump and load function Using the collection modules increases the cpu usage because we need to serialize the map into the struct if we load the document from the database. And if we want to save the struct to the database, the dump function is called, that serializes the struct into a map. Both functions take care about the key mapping as well. What do the generated functions look like in detail? Assuming we have the following collections defined: defmodule Label do use Collection document do attribute :name , String . t ( ) , default : &quot;warning&quot; end end defmodule User do use Collection document do attribute :first_name , String . t ( ) attribute :last_name , String . t ( ) attribute :email , String . t ( ) embeds_one :label , Label end end The collection module creates the load function like this: Map.put(%{ first_name : Map . get ( user , &quot;first_name&quot; ) , last_name : Map . get ( user , &quot;last_name&quot; ) , email : Map . get ( user , &quot;email&quot; ) , label : Label . load ( Map . get ( user , &quot;label&quot; ) ) }, : struct , User) The performance depends on the number of attributes and embedded structs. It seems, that using a map first is the fasted way to create a new struct. A few variations were tried out: new quoted load 2.43 M load manually created using Map.get 2.25 M - 1.08x slower +32.91 ns load manually created using [] 2.12 M - 1.15x slower +60.34 ns original load 0.82 M - 2.96x slower +805.70 ns The dump function looks like this: [ { &quot;first_name&quot; , user . first_name } , { &quot;last_name&quot; , user . last_name } , { &quot;email&quot; , user . email } , { &quot;label&quot; , Label . dump ( user . label ) } ] |&gt; Enum . filter ( fn { _key , value } -&gt; value != nil end ) |&gt; Map . new ( ) The load and dump function uses only the defined attributes and embedded structs. Unknown attributes are ignored. Default and derived values Attributes have two options: default: a value or a function, which is called, when a new struct is created derived: true to indicate, that is attribute should not be saved to the database If you call new/0 a new struct is returned filled with the default values. In case of a function the function is called to use the return value as default. attribute : created , DateTime . t ( ) , &amp; DateTime . utc_now / 0 If you mark an attribute as a derived attribute ( derived: true ) then the dump function will remove the attributes from the struct automatically for you, so these kind of attributes won't be saved in the database. attribute :id , String . t ( ) , derived : true Key mapping It is possible to define a different name for the keys. The name of the key is defined by using the :name option. attribute :very_long_name, String.t(), name: v The dump and load functions will use the name v instead of very_long_name : defmodule Label do use Mongo.Collection document do attribute :very_long_attribute , String . t ( ) , name : :v end end iex &gt; l = % Label { very_long_attribute : &quot;Hello&quot; } % Label { very_long_attribute : &quot;Hello&quot; } iex &gt; Label . dump ( l ) %{ &quot;v&quot; =&gt; &quot;Hello&quot; } iex &gt; dumped_l = Label . dump ( l ) %{ &quot;v&quot; =&gt; &quot;Hello&quot; } iex &gt; Label . load ( dumped_l ) % Label { very_long_attribute : &quot;Hello&quot; } You can reduce the size of the collection by using short attribute-names or use the :name option to import the documents for a migration. Collections In MongoDB, documents are written in collections. We can use the collection/2 macro to create a collection: defmodule Card do use Collection collection &quot;cards&quot; do attribute :title , String . t ( ) , default : &quot;new title&quot; end end The collection/2 macro creates a collection that is basically similar to a document, where an attribute for the ID is added automatically. Additionally, the attribute @collection is assigned and can be used as a constant in other functions. In the example above we only suppress a warning of the editor by @collection . The macro creates the following expression: @collection &quot;cards&quot; . By default, the following attribute is created for the ID: { :_id , BSON.ObjectId . t ( ) , &amp; Mongo . object_id / 0 } where the default value is created via the function &amp;Mongo.object_id/0 when calling new/0 : iex&gt; Card . new ( ) % Card { _id : # BSON.ObjectId &lt; 5 ec3d04a306a5f296448a695 &gt; , title : &quot;new title&quot; } Two additional reflection features are also provided: iex&gt; Card . __collection__ ( :id ) :_id iex(3)&gt; Card . __collection__ ( :collection ) &quot;cards&quot; MongoDB example We define the following collection: defmodule Card do use Collection @collection nil ## keeps the editor happy @id nil collection &quot;cards&quot; do attribute :title , String . t ( ) , default : &quot;new title&quot; end def insert_one ( % Card { } = card ) do with map &lt;- dump ( card ) , { :ok , _ } &lt;- Mongo . insert_one ( :mongo , @collection , map ) do :ok end end def find_one ( id ) do :mongo |&gt; Mongo . find_one ( @collection , %{ @id =&gt; id } ) |&gt; load ( ) end end Then we can call the functions insert_one and find_one . Thereby we always use the defined structs as parameters or get the struct as result: iex(1)&gt; card = Card . new ( ) % Card { _id : # BSON.ObjectId &lt; 5 ec3ed0d306a5f377943c23c &gt; , title : &quot;new title&quot; } iex(6)&gt; Card . insert_one ( card ) :ok iex(2)&gt; Card . find_one ( card . _id ) % XCard { _id : # BSON.ObjectId &lt; 5 ec3ecbf306a5f3779a5edaa &gt; , title : &quot;new title&quot; } ID generator In MongoDB it is common to use the attribute _id as id. The value is uses an ObjectId generated by the mongodb driver. This behavior can be specified by the module attribute @id_generator when using collection . The default setting is { :_id , BSON.ObjectId . t ( ) , &amp; Mongo . object_id / 0 } Now you can overwrite this tuple {name, type, function} as you like: @id_generator false # no ID creation @id_generator { id , String . t , &amp; IDGenerator . next ( ) / 0 } # customized name and generator @id_generator nil # use default: {:_id, BSON.ObjectId.t(), &amp;Mongo.object_id/0} Embedded documents Until now we had only shown simple attributes. It will only be interesting when we embed other structs. With the macros embeds_one/3 and embeds_many/3 , structs can be added to the attributes: Example embeds_one defmodule Label do use Collection document do attribute :name , String . t ( ) , default : &quot;warning&quot; attribute :color , String . t ( ) , default : :red end end defmodule Card do use Collection collection &quot;cards&quot; do attribute :title , String . t ( ) attribute :list , BSON.ObjectId . t ( ) attribute :created , DateString . t ( ) , default : &amp; DateTime . utc_now / 0 attribute :modified , DateString . t ( ) , default : &amp; DateTime . utc_now / 0 embeds_one :label , Label , default : &amp; Label . new / 0 end end If we now call new/0 , we get the following structure: iex(1)&gt; Card . new ( ) % Card { _id : # BSON.ObjectId &lt; 5 ec3f0f0306a5f3aa5418a24 &gt; , created : ~U[2020-05-19 14:45:04.141044Z] , label : % Label { color : :red , name : &quot;warning&quot; } , list : nil , modified : ~U[2020-05-19 14:45:04.141033Z] , title : nil } after_load/1 and before_dump/1 macros Sometimes you may want to perform post-processing after loading the data set, for example to create derived attributes. Conversely, before saving, you may want to drop the derived attributes so that they are not saved to the database. For this reason there are two macros after_load/1 and before_dump/1 . You can specify functions that are called after the load/0 or before the dump : Example embeds_many defmodule Board do use Collection collection &quot;boards&quot; do attribute :id , String . t ( ) ## derived attribute attribute :title , String . t ( ) attribute :created , DateString . t ( ) , default : &amp; DateTime . utc_now / 0 attribute :modified , DateString . t ( ) , default : &amp; DateTime . utc_now / 0 embeds_many :lists , BoardList after_load &amp; Board . after_load / 1 before_dump &amp; Board . before_dump / 1 end def after_load ( % Board { _id : id } = board ) do % Board { board | id : BSON.ObjectId . encode! ( id ) } end def before_dump ( board ) do % Board { board | id : nil } end def new ( title ) do new ( ) |&gt; Map . put ( :title , title ) |&gt; Map . put ( :lists , [ ] ) |&gt; after_load ( ) end def store ( board ) do with map &lt;- dump ( board ) , { :ok , _ } &lt;- Mongo . insert_one ( :mongo , @collection , map ) do :ok end end def fetch ( id ) do :mongo |&gt; Mongo . find_one ( @collection , %{ @id =&gt; id } ) |&gt; load ( ) end end In this example the attribute id is derived from the actual ID and stored as a binary. This attribute is often used and therefore we want to save the conversion of the ID. To avoid storing the derived attribute id , the before_dump/1 function is called, which removes the id from the struct: iex(1)&gt; board = Board . new ( &quot;Vega&quot; ) % Board { _id : # BSON.ObjectId &lt; 5 ec3f802306a5f3ee3b71cf2 &gt; , created : ~U[2020-05-19 15:15:14.374556Z] , id : &quot;5ec3f802306a5f3ee3b71cf2&quot; , lists : [ ] , modified : ~U[2020-05-19 15:15:14.374549Z] , title : &quot;Vega&quot; } iex(2)&gt; Board . store ( board ) :ok iex(3)&gt; Board . fetch ( board . _id ) % Board { _id : # BSON.ObjectId &lt; 5 ec3f802306a5f3ee3b71cf2 &gt; , created : ~U[2020-05-19 15:15:14.374Z] , id : &quot;5ec3f802306a5f3ee3b71cf2&quot; , lists : [ ] , modified : ~U[2020-05-19 15:15:14.374Z] , title : &quot;Vega&quot; } If we call the document in the Mongo shell, we see that the attribute id was not stored there: &gt; db . boards . findOne ( { &quot;_id&quot; : ObjectId ( &quot;5ec3f802306a5f3ee3b71cf2&quot; ) } ) { &quot;_id&quot; : ObjectId ( &quot;5ec3f802306a5f3ee3b71cf2&quot; ) , &quot;created&quot; : ISODate ( &quot;2020-05-19T15:15:14.374Z&quot; ) , &quot;lists&quot; : [ ] , &quot;modified&quot; : ISODate ( &quot;2020-05-19T15:15:14.374Z&quot; ) , &quot;title&quot; : &quot;Vega&quot; } Example timestamps defmodule Post do use Mongo.Collection collection &quot;posts&quot; do attribute :title , String . t ( ) timestamps ( ) end def new ( title ) do Map . put ( new ( ) , :title , title ) end def store ( post ) do MyRepo . insert_or_update ( post ) end end In this example the macro timestamps is used to create two DateTime attributes, inserted_at and updated_at . This macro is intented to use with the Repo module, as it will be responsible for updating the value of updated_at attribute before execute the action. iex(1)&gt; post = Post . new ( &quot;lorem ipsum dolor sit amet&quot; ) % Post { _id : # BSON.ObjectId &lt; 6327 a7099626f7f61607e179 &gt; , inserted_at : ~U[2022-09-18 23:17:29.087092Z] , title : &quot;lorem ipsum dolor sit amet&quot; , updated_at : ~U[2022-09-18 23:17:29.087070Z] } iex(2)&gt; Post . store ( post ) { :ok , %{ _id : # BSON.ObjectId &lt; 6327 a7099626f7f61607e179 &gt; , inserted_at : ~U[2022-09-18 23:17:29.087092Z] , title : &quot;lorem ipsum dolor sit amet&quot; , updated_at : ~U[2022-09-18 23:19:24.516648Z] } } Is possible to change the field names, like Ecto does, and also change the default behaviour: defmodule Comment do use Mongo.Collection collection &quot;comments&quot; do attribute :text , String . t ( ) timestamps ( inserted_at : :created , updated_at : :modified , default : &amp; __MODULE__ . truncated_date_time / 0 ) end def new ( text ) do Map . put ( new ( ) , :text , text ) end def truncated_date_time ( ) do utc_now = DateTime . utc_now ( ) DateTime . truncate ( utc_now , :second ) end end iex(1)&gt; comment = Comment . new ( &quot;useful comment&quot; ) % Comment { _id : # BSON.ObjectId &lt; 6327 aa979626f7f616ae5b4a &gt; , created : ~U[2022-09-18 23:32:39Z] , modified : ~U[2022-09-18 23:32:39Z] , text : &quot;useful comment&quot; } iex(2)&gt; { :ok , comment } = MyRepo . insert ( comment ) { :ok , % Comment { _id : # BSON.ObjectId &lt; 6327 aa979626f7f616ae5b4a &gt; , created : ~U[2022-09-18 23:32:39Z] , modified : ~U[2022-09-18 23:32:42Z] , text : &quot;useful comment&quot; } } iex(3)&gt; { :ok , comment } = MyRepo . update ( %{ comment | text : &quot;not so useful comment&quot; } ) { :ok , % Comment { _id : # BSON.ObjectId &lt; 6327 aa979626f7f616ae5b4a &gt; , created : ~U[2022-09-18 23:32:39Z] , modified : ~U[2022-09-18 23:32:46Z] , text : not so useful comment &quot; } } The timestamps macro has some limitations as it does not run in batch commands like insert_all or update_all , nor does it update embedded documents.","ref":"Mongo.Collection.html"},{"type":"function","title":"Mongo.Collection.__attribute__/4","doc":"Adds the attribute to the attributes list.","ref":"Mongo.Collection.html#__attribute__/4"},{"type":"function","title":"Mongo.Collection.__embeds_many__/5","doc":"Adds the struct to the embeds_many list.","ref":"Mongo.Collection.html#__embeds_many__/5"},{"type":"function","title":"Mongo.Collection.__embeds_one__/4","doc":"Adds the struct to the embeds_one list.","ref":"Mongo.Collection.html#__embeds_one__/4"},{"type":"macro","title":"Mongo.Collection.__id__/2","doc":"Inserts the specified @id_generator to the list of attributes. Calls add_id/3 .","ref":"Mongo.Collection.html#__id__/2"},{"type":"macro","title":"Mongo.Collection.__type__/1","doc":"Inserts boilercode for the @type attribute.","ref":"Mongo.Collection.html#__type__/1"},{"type":"function","title":"Mongo.Collection.add_id/3","doc":"Inserts the specified @id_generator to the list of attributes.","ref":"Mongo.Collection.html#add_id/3"},{"type":"function","title":"Mongo.Collection.add_name/3","doc":"Inserts name option for the attribute, embeds_one and embeds_many.","ref":"Mongo.Collection.html#add_name/3"},{"type":"macro","title":"Mongo.Collection.after_load/1","doc":"Defines the after_load/1 function.","ref":"Mongo.Collection.html#after_load/1"},{"type":"macro","title":"Mongo.Collection.attribute/3","doc":"Adds the attribute to the attributes list. It call __attribute__/4 function.","ref":"Mongo.Collection.html#attribute/3"},{"type":"macro","title":"Mongo.Collection.before_dump/1","doc":"Defines the before_dump/1 function.","ref":"Mongo.Collection.html#before_dump/1"},{"type":"macro","title":"Mongo.Collection.collection/2","doc":"Defines a struct as a collection with id generator and a collection. Inside a collection block, each attribute is defined through the attribute/3 macro.","ref":"Mongo.Collection.html#collection/2"},{"type":"function","title":"Mongo.Collection.compile_dump_steps/1","doc":"","ref":"Mongo.Collection.html#compile_dump_steps/1"},{"type":"function","title":"Mongo.Collection.compile_load_steps/3","doc":"","ref":"Mongo.Collection.html#compile_load_steps/3"},{"type":"macro","title":"Mongo.Collection.document/1","doc":"Defines a struct as a document without id generator and a collection. These documents are used to be embedded within collection structs. Inside a document block, each attribute is defined through the attribute/3 macro.","ref":"Mongo.Collection.html#document/1"},{"type":"function","title":"Mongo.Collection.dump/1","doc":"","ref":"Mongo.Collection.html#dump/1"},{"type":"function","title":"Mongo.Collection.dump/2","doc":"","ref":"Mongo.Collection.html#dump/2"},{"type":"macro","title":"Mongo.Collection.embeds_many/3","doc":"Adds the struct to the embeds_many list. Calls __embeds_many__","ref":"Mongo.Collection.html#embeds_many/3"},{"type":"macro","title":"Mongo.Collection.embeds_one/3","doc":"Adds the struct to the embeds_one list. Calls __embeds_one__","ref":"Mongo.Collection.html#embeds_one/3"},{"type":"function","title":"Mongo.Collection.filter_nils/1","doc":"","ref":"Mongo.Collection.html#filter_nils/1"},{"type":"function","title":"Mongo.Collection.has_dump_function?/1","doc":"Returns true, if the Module has the dump/1 function.","ref":"Mongo.Collection.html#has_dump_function?/1"},{"type":"function","title":"Mongo.Collection.has_load_function?/1","doc":"Returns true, if the Module has the load/1 function.","ref":"Mongo.Collection.html#has_load_function?/1"},{"type":"function","title":"Mongo.Collection.struct_args/1","doc":"Returns the default arguments for the struct. They are used to provide the default values in the new/0 call.","ref":"Mongo.Collection.html#struct_args/1"},{"type":"function","title":"Mongo.Collection.struct_args/2","doc":"","ref":"Mongo.Collection.html#struct_args/2"},{"type":"function","title":"Mongo.Collection.timestamp/2","doc":"Inserts src_name for the timestamp attribute","ref":"Mongo.Collection.html#timestamp/2"},{"type":"macro","title":"Mongo.Collection.timestamps/1","doc":"Defines the timestamps/1 function.","ref":"Mongo.Collection.html#timestamps/1"},{"type":"function","title":"Mongo.Collection.timestamps/3","doc":"","ref":"Mongo.Collection.html#timestamps/3"},{"type":"type","title":"Mongo.Collection.t/0","doc":"","ref":"Mongo.Collection.html#t:t/0"},{"type":"module","title":"Mongo.DeleteResult","doc":"The successful result struct of Mongo.delete_one/4 and Mongo.delete_many/4 . Its fields are: :deleted_count - Number of deleted documents :acknowledged - Write-concern","ref":"Mongo.DeleteResult.html"},{"type":"type","title":"Mongo.DeleteResult.t/0","doc":"","ref":"Mongo.DeleteResult.html#t:t/0"},{"type":"protocol","title":"Mongo.Encoder","doc":"","ref":"Mongo.Encoder.html"},{"type":"function","title":"Mongo.Encoder.encode/1","doc":"","ref":"Mongo.Encoder.html#encode/1"},{"type":"type","title":"Mongo.Encoder.t/0","doc":"All the types that implement this protocol.","ref":"Mongo.Encoder.html#t:t/0"},{"type":"module","title":"Mongo.Events","doc":"","ref":"Mongo.Events.html"},{"type":"module","title":"Mongo.GridFs.Bucket","doc":"This is the MongoDB Bucket struct, which specifies the underlying collections to support GridFS. There are always two kind of collections used for storing files by GridFS. The fs.files collection contains the meta information about the file and the fs.chunks collection contains the data of the file chunked into blocks of bytes. The names of the collection and the size of the block is defined by the following options: The bucket has some configuration options: :chunk_size - The chunk size in bytes. Defaults to 255*1024 :name - The bucket name. Defaults to fs The bucket checks whether the indexes already exist before attempting to create them. The names of the created indexes are &quot;filename_1_uploadDate_1&quot; and &quot;files_id_1_n_1&quot;","ref":"Mongo.GridFs.Bucket.html"},{"type":"function","title":"Mongo.GridFs.Bucket.add_session/2","doc":"In case of using transaction you need to add the session to the bucket. This functions adds the session pid to the bucket.","ref":"Mongo.GridFs.Bucket.html#add_session/2"},{"type":"function","title":"Mongo.GridFs.Bucket.check_and_chunks_files_index/1","doc":"","ref":"Mongo.GridFs.Bucket.html#check_and_chunks_files_index/1"},{"type":"function","title":"Mongo.GridFs.Bucket.check_and_create_files_index/1","doc":"","ref":"Mongo.GridFs.Bucket.html#check_and_create_files_index/1"},{"type":"function","title":"Mongo.GridFs.Bucket.chunks_collection_name/1","doc":"Returns the collection name for the chunks collection, default is fs.chunks.","ref":"Mongo.GridFs.Bucket.html#chunks_collection_name/1"},{"type":"function","title":"Mongo.GridFs.Bucket.delete/2","doc":"Given a id , delete this stored file’s files collection document and associated chunks from a GridFS bucket.","ref":"Mongo.GridFs.Bucket.html#delete/2"},{"type":"function","title":"Mongo.GridFs.Bucket.drop/1","doc":"Drops the files and chunks collections associated with this bucket.","ref":"Mongo.GridFs.Bucket.html#drop/1"},{"type":"function","title":"Mongo.GridFs.Bucket.files_collection_name/1","doc":"Returns the collection name for the files collection, default is fs.files.","ref":"Mongo.GridFs.Bucket.html#files_collection_name/1"},{"type":"function","title":"Mongo.GridFs.Bucket.find/3","doc":"Returns a cursor from the fs.files collection.","ref":"Mongo.GridFs.Bucket.html#find/3"},{"type":"function","title":"Mongo.GridFs.Bucket.find_one/2","doc":"Finds one file document by file_id specified either as a string or BSON.ObjectId .","ref":"Mongo.GridFs.Bucket.html#find_one/2"},{"type":"function","title":"Mongo.GridFs.Bucket.index_member?/4","doc":"","ref":"Mongo.GridFs.Bucket.html#index_member?/4"},{"type":"function","title":"Mongo.GridFs.Bucket.new/2","doc":"Creates a new Bucket with a existing connection using the default values. It just contains the name of the collections (fs) and the chunk size (255KB). The bucket checks the index for both collections as well. In case of multiple upload or downloads just create only one bucket and reuse it.","ref":"Mongo.GridFs.Bucket.html#new/2"},{"type":"function","title":"Mongo.GridFs.Bucket.rename/3","doc":"Renames the stored file with the specified file_id.","ref":"Mongo.GridFs.Bucket.html#rename/3"},{"type":"type","title":"Mongo.GridFs.Bucket.t/0","doc":"","ref":"Mongo.GridFs.Bucket.html#t:t/0"},{"type":"module","title":"Mongo.GridFs.Download","doc":"The main entry point for downloading files from the grid-fs specified by the bucket struct.","ref":"Mongo.GridFs.Download.html"},{"type":"function","title":"Mongo.GridFs.Download.find_and_stream/2","doc":"Same as above, but returns also the file document.","ref":"Mongo.GridFs.Download.html#find_and_stream/2"},{"type":"function","title":"Mongo.GridFs.Download.find_one_file/2","doc":"","ref":"Mongo.GridFs.Download.html#find_one_file/2"},{"type":"function","title":"Mongo.GridFs.Download.open_download_stream/2","doc":"Opens a Stream from which the application can read the contents of the stored file specified by fileId. The fileId can be a string, an ObjectId or just a map with the keys length and _id . In case of the map the function tries to stream the chunks described by the length and the _id values. Returns a Stream.","ref":"Mongo.GridFs.Download.html#open_download_stream/2"},{"type":"type","title":"Mongo.GridFs.Download.result/0","doc":"","ref":"Mongo.GridFs.Download.html#t:result/0"},{"type":"module","title":"Mongo.GridFs.Upload","doc":"The main entry point for uploading files into the grid-fs specified by the bucket struct.","ref":"Mongo.GridFs.Upload.html"},{"type":"function","title":"Mongo.GridFs.Upload.open_upload_stream/3","doc":"Opens a stream that the application can write the contents of the file to. The driver generates the file id. User data for the 'metadata' field of the files collection document.","ref":"Mongo.GridFs.Upload.html#open_upload_stream/3"},{"type":"module","title":"Mongo.GridFs.UploadStream","doc":"This is the upload stream for save streams into the grid fs. First you need to create a bucket. The bucket contains the configuration for the grid fs. Example: streaming the file ./test/data/test.jpg into the grid fs using the upload-stream bucket = Bucket . new ( pid ) upload_stream = Upload . open_upload_stream ( bucket , &quot;test.jpg&quot; , j : true ) src_filename = &quot;./test/data/test.jpg&quot; File . stream! ( src_filename , [ ] , 512 ) |&gt; Stream . into ( upload_stream ) |&gt; Stream . run ( )","ref":"Mongo.GridFs.UploadStream.html"},{"type":"function","title":"Mongo.GridFs.UploadStream.new/3","doc":"Creates a new upload stream to insert a file into the grid-fs.","ref":"Mongo.GridFs.UploadStream.html#new/3"},{"type":"type","title":"Mongo.GridFs.UploadStream.t/0","doc":"","ref":"Mongo.GridFs.UploadStream.html#t:t/0"},{"type":"module","title":"Mongo.InsertManyResult","doc":"The successful result struct of Mongo.insert_many/4 . Its fields are: :inserted_ids - The ids of the inserted documents indexed by their order","ref":"Mongo.InsertManyResult.html"},{"type":"type","title":"Mongo.InsertManyResult.t/0","doc":"","ref":"Mongo.InsertManyResult.html#t:t/0"},{"type":"module","title":"Mongo.InsertOneResult","doc":"The successful result struct of Mongo.insert_one/4 . Its fields are: :inserted_id - The id of the inserted document","ref":"Mongo.InsertOneResult.html"},{"type":"type","title":"Mongo.InsertOneResult.t/0","doc":"","ref":"Mongo.InsertOneResult.html#t:t/0"},{"type":"module","title":"Mongo.Messages","doc":"This module encodes and decodes the data from and to the mongodb server. We only support MongoDB &gt;= 3.2 and use op_query with the hack collection &quot;$cmd&quot; Other op codes are deprecated. Therefore only op_reply and op_query are supported.","ref":"Mongo.Messages.html"},{"type":"function","title":"Mongo.Messages.decode_header/1","doc":"Decodes the header from response of a request sent by the mongodb server","ref":"Mongo.Messages.html#decode_header/1"},{"type":"function","title":"Mongo.Messages.decode_msg/1","doc":"","ref":"Mongo.Messages.html#decode_msg/1"},{"type":"function","title":"Mongo.Messages.decode_reply/1","doc":"Decodes a reply message from the response","ref":"Mongo.Messages.html#decode_reply/1"},{"type":"function","title":"Mongo.Messages.decode_response/2","doc":"Decodes the response body of a request sent by the mongodb server","ref":"Mongo.Messages.html#decode_response/2"},{"type":"function","title":"Mongo.Messages.decode_sections/1","doc":"","ref":"Mongo.Messages.html#decode_sections/1"},{"type":"function","title":"Mongo.Messages.decode_sections/2","doc":"","ref":"Mongo.Messages.html#decode_sections/2"},{"type":"function","title":"Mongo.Messages.decode_sequence/1","doc":"","ref":"Mongo.Messages.html#decode_sequence/1"},{"type":"function","title":"Mongo.Messages.encode/2","doc":"","ref":"Mongo.Messages.html#encode/2"},{"type":"macro","title":"Mongo.Messages.msg_header/1","doc":"","ref":"Mongo.Messages.html#msg_header/1"},{"type":"macro","title":"Mongo.Messages.msg_header/2","doc":"","ref":"Mongo.Messages.html#msg_header/2"},{"type":"macro","title":"Mongo.Messages.op_msg/1","doc":"","ref":"Mongo.Messages.html#op_msg/1"},{"type":"macro","title":"Mongo.Messages.op_msg/2","doc":"","ref":"Mongo.Messages.html#op_msg/2"},{"type":"macro","title":"Mongo.Messages.op_query/1","doc":"","ref":"Mongo.Messages.html#op_query/1"},{"type":"macro","title":"Mongo.Messages.op_query/2","doc":"","ref":"Mongo.Messages.html#op_query/2"},{"type":"macro","title":"Mongo.Messages.op_reply/1","doc":"","ref":"Mongo.Messages.html#op_reply/1"},{"type":"macro","title":"Mongo.Messages.op_reply/2","doc":"","ref":"Mongo.Messages.html#op_reply/2"},{"type":"macro","title":"Mongo.Messages.payload/1","doc":"","ref":"Mongo.Messages.html#payload/1"},{"type":"macro","title":"Mongo.Messages.payload/2","doc":"","ref":"Mongo.Messages.html#payload/2"},{"type":"macro","title":"Mongo.Messages.section/1","doc":"","ref":"Mongo.Messages.html#section/1"},{"type":"macro","title":"Mongo.Messages.section/2","doc":"","ref":"Mongo.Messages.html#section/2"},{"type":"macro","title":"Mongo.Messages.sequence/1","doc":"","ref":"Mongo.Messages.html#sequence/1"},{"type":"macro","title":"Mongo.Messages.sequence/2","doc":"","ref":"Mongo.Messages.html#sequence/2"},{"type":"module","title":"Mongo.MongoDBConnection","doc":"Implementation of the DBConnection behaviour module.","ref":"Mongo.MongoDBConnection.html"},{"type":"module","title":"Mongo.Monitor","doc":"Each server has a monitor process. The monitor process is created by the topology process. If the network connection is working, then the monitor process reports this and the topology process starts the connection pool. Per server we get 1 + pool size connections to each server. After waiting for heartbeat_frequency_ms milliseconds, the monitor process calls hello command and reports the result to the topology process. The result of the hello command is mapped the ServerDescription structure and sent to the topology process, which updates it internal data structure. see https://github.com/mongodb/specifications/blob/master/source/server-discovery-and-monitoring/server-discovery-and-monitoring.rst#monitoring","ref":"Mongo.Monitor.html"},{"type":"function","title":"Mongo.Monitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mongo.Monitor.html#child_spec/1"},{"type":"function","title":"Mongo.Monitor.connected/3","doc":"Report the connection event, so the topology process can now create the connection pool.","ref":"Mongo.Monitor.html#connected/3"},{"type":"function","title":"Mongo.Monitor.force_check/1","doc":"Try to update the server description.","ref":"Mongo.Monitor.html#force_check/1"},{"type":"function","title":"Mongo.Monitor.get_state/1","doc":"","ref":"Mongo.Monitor.html#get_state/1"},{"type":"function","title":"Mongo.Monitor.info/1","doc":"","ref":"Mongo.Monitor.html#info/1"},{"type":"function","title":"Mongo.Monitor.init/1","doc":"Initialize the monitor process","ref":"Mongo.Monitor.html#init/1"},{"type":"function","title":"Mongo.Monitor.modes/0","doc":"Returns the possible modes of the monitor process.","ref":"Mongo.Monitor.html#modes/0"},{"type":"function","title":"Mongo.Monitor.set_heartbeat_frequency_ms/2","doc":"","ref":"Mongo.Monitor.html#set_heartbeat_frequency_ms/2"},{"type":"function","title":"Mongo.Monitor.start_link/1","doc":"","ref":"Mongo.Monitor.html#start_link/1"},{"type":"function","title":"Mongo.Monitor.terminate/2","doc":"In case of terminating we stop the our linked processes as well: connection streaming process","ref":"Mongo.Monitor.html#terminate/2"},{"type":"module","title":"Mongo.OrderedBulk","doc":"An ordered bulk is filled in the memory with the bulk operations. If the ordered bulk is written to the database, the order is preserved. Only same types of operation are grouped and only if they have been inserted one after the other. Example alias Mongo.OrderedBulk alias Mongo.BulkWrite bulk = &quot;bulk&quot; |&gt; OrderedBulk . new ( ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Greta&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Tom&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Waldo&quot; } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Greta&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Tom&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_many ( %{ kind : &quot;dog&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;cat&quot; } } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) BulkWrite . write ( :mongo , bulk , w : 1 ) This example would not work by using an unordered bulk, because the OrderedBulk.update_many would executed too early. To reduce the memory usage the ordered bulk can be used with streams as well. Example alias Mongo.OrderedBulk 1 .. 1000 |&gt; Stream . map ( fn 1 -&gt; BulkOps . get_insert_one ( %{ count : 1 } ) 1000 -&gt; BulkOps . get_delete_one ( %{ count : 999 } ) i -&gt; BulkOps . get_update_one ( %{ count : i - 1 } , %{ &quot;$set&quot; : %{ count : i } } ) end ) |&gt; OrderedBulk . write ( :mongo , &quot;bulk&quot; , 25 ) |&gt; Stream . run ( ) Of course, this example is a bit silly. A sequence of update operations is created that only work in the correct order.","ref":"Mongo.OrderedBulk.html"},{"type":"function","title":"Mongo.OrderedBulk.delete_many/2","doc":"Appends a delete operation with :limit = 0 . Example: Mongo.OrderedBulk . delete_many ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ delete : { %{ name : &quot;Waldo&quot; } , [ limit : 0 ] } ] }","ref":"Mongo.OrderedBulk.html#delete_many/2"},{"type":"function","title":"Mongo.OrderedBulk.delete_one/2","doc":"Appends a delete operation with :limit = 1 . Example: Mongo.OrderedBulk . delete_one ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ delete : { %{ name : &quot;Waldo&quot; } , [ limit : 1 ] } ] }","ref":"Mongo.OrderedBulk.html#delete_one/2"},{"type":"function","title":"Mongo.OrderedBulk.empty?/1","doc":"Returns true, if the bulk is empty, that means it contains no inserts, updates or deletes operations","ref":"Mongo.OrderedBulk.html#empty?/1"},{"type":"function","title":"Mongo.OrderedBulk.insert_one/2","doc":"Appends an insert operation. Example: Mongo.OrderedBulk . insert_one ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ insert : %{ name : &quot;Waldo&quot; } ] }","ref":"Mongo.OrderedBulk.html#insert_one/2"},{"type":"function","title":"Mongo.OrderedBulk.new/1","doc":"Creates an empty ordered bulk for a collection. Example: Mongo . orderedBulk . new ( &quot;bulk&quot; ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ ] }","ref":"Mongo.OrderedBulk.html#new/1"},{"type":"function","title":"Mongo.OrderedBulk.push/2","doc":"Appends a bulk operation to the ordered bulk.","ref":"Mongo.OrderedBulk.html#push/2"},{"type":"function","title":"Mongo.OrderedBulk.replace_one/4","doc":"Appends a replace operation with :multi = false . Example: Mongo.OrderedBulk . replace_one ( bulk , %{ name : &quot;Waldo&quot; } , %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ update : { %{ name : &quot;Waldo&quot; } , %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } , [ multi : false ] } ] }","ref":"Mongo.OrderedBulk.html#replace_one/4"},{"type":"function","title":"Mongo.OrderedBulk.update_many/4","doc":"Appends a update operation with :multi = true . Example: Mongo.OrderedBulk . update_many ( bulk , %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ update : { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : true ] } ] }","ref":"Mongo.OrderedBulk.html#update_many/4"},{"type":"function","title":"Mongo.OrderedBulk.update_one/4","doc":"Appends a update operation with :multi = false . Example: Mongo.OrderedBulk . update_one ( bulk , %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) % Mongo.OrderedBulk { coll : &quot;bulk&quot; , ops : [ update : { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : false ] } ] }","ref":"Mongo.OrderedBulk.html#update_one/4"},{"type":"function","title":"Mongo.OrderedBulk.write/5","doc":"Returns a stream chunk function that can be used with streams. The limit specifies the number of operation hold in the memory while processing the stream inputs. The inputs of the stream should be Mongo.BulkOps.bulk_op . See Mongo.BulkOps","ref":"Mongo.OrderedBulk.html#write/5"},{"type":"type","title":"Mongo.OrderedBulk.t/0","doc":"","ref":"Mongo.OrderedBulk.html#t:t/0"},{"type":"module","title":"Mongo.PBKDF2","doc":"PBKDF2 implements PBKDF2 (Password-Based Key Derivation Function 2), part of PKCS #5 v2.0 (Password-Based Cryptography Specification). It can be used to derive a number of keys for various purposes from a given secret. This lets applications have a single secure secret, but avoid reusing that key in multiple incompatible contexts. see http://tools.ietf.org/html/rfc2898#section-5.2","ref":"Mongo.PBKDF2.html"},{"type":"function","title":"Mongo.PBKDF2.generate/3","doc":"Returns a derived key suitable for use. Options :iterations - defaults to 1000 (increase to at least 2^16 if used for passwords) :length - a length in octets for the derived key. Defaults to 32 :digest - an hmac function to use as the pseudo-random function. Defaults to :sha256","ref":"Mongo.PBKDF2.html#generate/3"},{"type":"module","title":"Mongo.PasswordSafe","doc":"The password safe stores the password while parsing the url and/or the options to avoid it from logging while the sasl logger is activated. The password is encrypted before storing in the GenServer's state. It will be encrypted before returning. This should help, that the password is not stored as plain text in the memory.","ref":"Mongo.PasswordSafe.html"},{"type":"function","title":"Mongo.PasswordSafe.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mongo.PasswordSafe.html#child_spec/1"},{"type":"function","title":"Mongo.PasswordSafe.get_password/1","doc":"","ref":"Mongo.PasswordSafe.html#get_password/1"},{"type":"function","title":"Mongo.PasswordSafe.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Mongo.PasswordSafe.html#init/1"},{"type":"function","title":"Mongo.PasswordSafe.new/0","doc":"","ref":"Mongo.PasswordSafe.html#new/0"},{"type":"function","title":"Mongo.PasswordSafe.set_password/2","doc":"","ref":"Mongo.PasswordSafe.html#set_password/2"},{"type":"module","title":"Mongo.Query","doc":"This is the query implementation for the Query Protocol Encoding and decoding does not take place at this point, but is directly performed into the functions of Mongo.MongoDBConnection.Utils.","ref":"Mongo.Query.html"},{"type":"module","title":"Mongo.ReadPreference","doc":"Determines which servers are considered suitable for read operations A read preference consists of a mode and optional tag_sets , max_staleness_ms, and hedge . The mode prioritizes between primaries and secondaries to produce either a single suitable server or a list of candidate servers. If tag_sets and maxStalenessSeconds are set, they determine which candidate servers are eligible for selection. If hedge is set, it configures how server hedged reads are used. The default mode is :primary . The default tag_sets is a list with an empty tag set: [{}]. The default max_staleness_ms is unset. The default hedge is unset. mode :primary Only an available primary is suitable. :secondary All secondaries (and only secondaries) are candidates, but only eligible candidates (i.e. after applying tag_sets and maxStalenessSeconds) are suitable. :primary_preferred If a primary is available, only the primary is suitable. Otherwise, all secondaries are candidates, but only eligible secondaries are suitable. :secondary_preferred All secondaries are candidates. If there is at least one eligible secondary, only eligible secondaries are suitable. Otherwise, when there are no eligible secondaries, the primary is suitable. :nearest The primary and all secondaries are candidates, but only eligible candidates are suitable.","ref":"Mongo.ReadPreference.html"},{"type":"function","title":"Mongo.ReadPreference.add_read_preference/2","doc":"Add read preference to the cmd","ref":"Mongo.ReadPreference.html#add_read_preference/2"},{"type":"function","title":"Mongo.ReadPreference.mongos/1","doc":"","ref":"Mongo.ReadPreference.html#mongos/1"},{"type":"function","title":"Mongo.ReadPreference.primary/1","doc":"","ref":"Mongo.ReadPreference.html#primary/1"},{"type":"function","title":"Mongo.ReadPreference.slave_ok/1","doc":"From the specs: Use of slaveOk There are two usages of slaveOK: A driver query parameter that predated read preference modes and tag set lists. A wire protocol flag on OP_QUERY operations","ref":"Mongo.ReadPreference.html#slave_ok/1"},{"type":"type","title":"Mongo.ReadPreference.t/0","doc":"","ref":"Mongo.ReadPreference.html#t:t/0"},{"type":"behaviour","title":"Mongo.Repo","doc":"Defines a repository. A repository serves as a convenience module for a mongodb instance. To include the Mongo.Repo module in your application, you can put the use macro in your app's Repo module. defmodule MyApp.Repo do use Mongo.Repo , otp_app : :my_app , topology : :mongo end With that in place we can configure the Repo: config :my_app , MyApp.Repo , url : &quot;mongodb://localhost:27017/my-app-dev&quot; , timeout : 60_000 , idle_interval : 10_000 , queue_target : 5_000 For a complete list of configuration options take a look at Mongo . Finally we can add the Mongo instance to our application supervision tree children = [ # ... { Mongo , MyApp.Repo . config ( ) } , # ... ] Read-only repositories To explicitly set a repository as read-only, we can pass in the :read_only flag to use : use Mongo.Repo , otp_app : :my_app , topology : :mongo , read_only : true The read-only option will not include any write operation related functions in the module.","ref":"Mongo.Repo.html"},{"type":"callback","title":"Mongo.Repo.aggregate/3","doc":"Performs aggregation operation using the aggregation pipeline on the given collection module and returns a list of collection structs. For all options see Options Example MyApp.Repo . aggregate ( Post , [ %{ &quot;$match&quot; =&gt; %{ title : title } } , %{ &quot;$sort&quot; =&gt; [ { &quot;title&quot; , - 1 } ] } , %{ &quot;$limit&quot; =&gt; 10 } ] )","ref":"Mongo.Repo.html#c:aggregate/3"},{"type":"callback","title":"Mongo.Repo.all/3","doc":"Selects documents for the collection defined in the given module and returns a list of collection structs for the given filter For all options see Options Example MyApp.Repo . all ( Post , %{ title : title } ) MyApp.Repo . all ( Post , %{ title : title } , batch_size : 2 )","ref":"Mongo.Repo.html#c:all/3"},{"type":"callback","title":"Mongo.Repo.config/0","doc":"Returns the mongo configuration stored in the :otp_app environment.","ref":"Mongo.Repo.html#c:config/0"},{"type":"callback","title":"Mongo.Repo.count/3","doc":"Returns the count of documents in the given collection module for the given filter. Options :limit - Maximum number of documents to fetch with the cursor :skip - Number of documents to skip before returning the first Example MyApp.Repo . count ( Post )","ref":"Mongo.Repo.html#c:count/3"},{"type":"callback","title":"Mongo.Repo.delete/2","doc":"Deletes a document struct from the database and returns a {:ok, doc} tuple. For all options see Options Example MyApp.Repo . delete ( post )","ref":"Mongo.Repo.html#c:delete/2"},{"type":"callback","title":"Mongo.Repo.delete!/2","doc":"Same as delete/2 but raises an error.","ref":"Mongo.Repo.html#c:delete!/2"},{"type":"callback","title":"Mongo.Repo.delete_all/3","doc":"Deletes all documents for the given collection module and filter. For all options see Options Example MyApp.Repo . delete_all ( Post , %{ } ) MyApp.Repo . delete_all ( Post , %{ title : &quot;todelete&quot; } )","ref":"Mongo.Repo.html#c:delete_all/3"},{"type":"callback","title":"Mongo.Repo.exists?/3","doc":"Checks whether there are any documents in the given collection module for the given filter. Returns a boolean. Example MyApp.Repo . exists? ( Post , %{ title : title } )","ref":"Mongo.Repo.html#c:exists?/3"},{"type":"callback","title":"Mongo.Repo.fetch/3","doc":"Returns a single document struct for the collection defined in the given module and bson object id as a tuple of {:ok, document} . Returns {:error, :not_found} if no result was found. If multiple documents satisfy the query, this method returns the first document according to the natural order which reflects the order of documents on the disk. For all options see Options Example MyApp.Repo . fetch ( Post , id ) MyApp.Repo . fetch ( Post , id , read_concern : %{ level : &quot;local&quot; } )","ref":"Mongo.Repo.html#c:fetch/3"},{"type":"callback","title":"Mongo.Repo.fetch_by/3","doc":"Returns a single document struct for the collection defined in the given module and query as a tuple of {:ok, document} . Returns {:error, :not_found} if no result was found. If multiple documents satisfy the query, this method returns the first document according to the natural order which reflects the order of documents on the disk. For all options see Options Example MyApp.Repo . fetch_by ( Post , %{ title : title } ) MyApp.Repo . fetch_by ( Post , %{ title : title } , read_concern : %{ level : &quot;local&quot; } )","ref":"Mongo.Repo.html#c:fetch_by/3"},{"type":"callback","title":"Mongo.Repo.get/3","doc":"Returns a single document struct for the collection defined in the given module and bson object id. Returns nil if no result was found. If multiple documents satisfy the query, this method returns the first document according to the natural order which reflects the order of documents on the disk. For all options see Options Example MyApp.Repo . get ( Post , id ) MyApp.Repo . get ( Post , id , read_concern : %{ level : &quot;local&quot; } )","ref":"Mongo.Repo.html#c:get/3"},{"type":"callback","title":"Mongo.Repo.get_by/3","doc":"Returns a single document struct for the collection defined in the given module and query. Returns nil if no result was found. If multiple documents satisfy the query, this method returns the first document according to the natural order which reflects the order of documents on the disk. For all options see Options Example MyApp.Repo . get_by ( Post , %{ title : title } ) MyApp.Repo . get_by ( Post , %{ title : title } , read_concern : %{ level : &quot;local&quot; } )","ref":"Mongo.Repo.html#c:get_by/3"},{"type":"callback","title":"Mongo.Repo.insert/2","doc":"Inserts a new document struct into the database and returns a {:ok, doc} tuple. For all options see Options Example MyApp.Repo . insert ( Post . new ( ) )","ref":"Mongo.Repo.html#c:insert/2"},{"type":"callback","title":"Mongo.Repo.insert!/2","doc":"Same as insert/2 but raises an error.","ref":"Mongo.Repo.html#c:insert!/2"},{"type":"callback","title":"Mongo.Repo.insert_all/3","doc":"Inserts all given documents into the document in one write operation and returns an :ok tuple with the count of inserted documents as second element and the inserted ids as third element. Returns {:error, reason} on failure. Example MyApp.Repo . insert_all ( Post , [ %{ title : &quot;a&quot; } , %{ title : &quot;b&quot; } ] )","ref":"Mongo.Repo.html#c:insert_all/3"},{"type":"callback","title":"Mongo.Repo.insert_or_update/2","doc":"Upserts a document struct and returns a {:ok, doc} tuple. Example MyApp.Repo . insert_or_update ( Post . new ( ) )","ref":"Mongo.Repo.html#c:insert_or_update/2"},{"type":"callback","title":"Mongo.Repo.insert_or_update!/2","doc":"Same as c:insert_or_update/1 but raises an error.","ref":"Mongo.Repo.html#c:insert_or_update!/2"},{"type":"callback","title":"Mongo.Repo.stream/3","doc":"Selects documents for the collection defined in the given module and returns a stream of collection structs for the given filter For all options see Options Example MyApp.Repo . stream ( Post , %{ title : title } ) MyApp.Repo . stream ( Post , %{ title : title } , batch_size : 2 )","ref":"Mongo.Repo.html#c:stream/3"},{"type":"callback","title":"Mongo.Repo.transaction/2","doc":"Convenient function for running multiple write commands in a transaction. In case of TransientTransactionError or UnknownTransactionCommitResult the function will retry the whole transaction or the commit of the transaction. You can specify a timeout ( :transaction_retry_timeout_s ) to limit the time of repeating. The default value is 120 seconds. If you don't wait so long, you call transaction with the option transaction_retry_timeout_s: 10 . In this case after 10 seconds of retrying, the function will return an error. You can nest the function calls. In this case the first session will be reused.","ref":"Mongo.Repo.html#c:transaction/2"},{"type":"callback","title":"Mongo.Repo.update/2","doc":"Updates a document struct and returns a {:ok, doc} tuple. Example post = MyApp.Repo . insert! ( Post . new ( ) ) MyApp.Repo . update ( %{ post | title : &quot;new&quot; } )","ref":"Mongo.Repo.html#c:update/2"},{"type":"callback","title":"Mongo.Repo.update!/2","doc":"Same as c:update/1 but raises an error.","ref":"Mongo.Repo.html#c:update!/2"},{"type":"callback","title":"Mongo.Repo.update_all/4","doc":"Applies the updates for the documents in the given collection module and filter. Uses MongoDB update operators to specify the updates. For more information and all options please refer to the MongoDB documentation Example MyApp.Repo . update_all ( Post , %{ } , %{ &quot;$set&quot; =&gt; %{ title : &quot;updated&quot; } } ) MyApp.Repo . update_all ( Post , %{ title : &quot;old&quot; } , %{ &quot;$set&quot; =&gt; %{ title : &quot;updated&quot; } } )","ref":"Mongo.Repo.html#c:update_all/4"},{"type":"type","title":"Mongo.Repo.t/0","doc":"","ref":"Mongo.Repo.html#t:t/0"},{"type":"module","title":"Mongo.Session","doc":"This module implements the details of the transactions api ( see specs ). In case of MongoDB 3.6 or greater the driver uses sessions for each operation. If no session is created the driver will create a so-called implicit session. A session is a UUID-Number which is added to some operations. The sessions are used to manage the transaction state as well. In most situation you need not to create a session instance, so the api of the driver is not changed. In case of multiple insert statements you can use transaction (MongoDB 4.x) to be sure that all operations are grouped like a single operation. Prerequisites for transactions are: MongoDB 4.x must be used as replica set or cluster deployment. The collection used in the operations must already exist. Some operation are not allowed (For example: create index or call count). Example alias Mongo.Session { :ok , session } = Session . start_session ( top , :write , [ ] ) :ok = Session . start_transaction ( session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } , session : session ) :ok = Session . commit_transaction ( session ) :ok = Session . end_session ( top , session ) First you start a explicit session and a transactions. Use the session for each insert statement as an options with key :session otherwise the insert statement won't be executed in the transaction. After that you commit the transaction and end the session by calling end_session . Convenient API for Transactions This method is responsible for starting a transaction, invoking a callback, and committing a transaction. The callback is expected to execute one or more operations with the transaction; however, that is not enforced. The callback is allowed to execute other operations not associated with the transaction. Example { :ok , ids } = Mongo . transaction ( top , fn -&gt; { :ok , % InsertOneResult { :inserted_id =&gt; id1 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id2 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id3 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } ) { :ok , [ id1 , id2 , id3 ] } end , w : 3 ) If the callback is successful then it returns a tuple with the keyword :ok and a used defined result like {:ok, [id1, id2, id3]} . In this example we use the write concern w: 3 . The write concern used in the insert operation will be removed by the driver. It is applied in the commit transaction command. Implicit vs explicit sessions In most cases the driver will create implicit sessions for you. The session is put in the process' dictionary under the key :session and the opts is extended by :session as well. This behaviour is specified by the mongodb specification for drivers . If you use the :causal_consistency flag, then you need to create an explicit session: alias Mongo.Session { :ok , session } = Session . start_session ( top , :write , causal_consistency : true ) Mongo . delete_many ( top , &quot;dogs&quot; , %{ &quot;Greta&quot; } , session : session , w : :majority ) { :ok , 0 } = Mongo . count ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , session : session , read_concern : %{ level : :majority } ) :ok = Session . end_session ( top , session ) For more information about causal consistency see the officially documentation . If you want to use transaction, then you need to create a session as well: alias Mongo.Session { :ok , session } = Session . start_session ( top , :write , [ ] ) :ok = Session . start_transaction ( session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } , session : session ) :ok = Session . commit_transaction ( session ) :ok = Session . end_session ( top , session ) You can shorten this code by using the with_transaction function: { :ok , ids } = Mongo . transaction ( top , fn -&gt; { :ok , % InsertOneResult { :inserted_id =&gt; id1 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id2 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id3 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } ) { :ok , [ id1 , id2 , id3 ] } end , w : 1 )","ref":"Mongo.Session.html"},{"type":"function","title":"Mongo.Session.abort_transaction/1","doc":"Abort the current transaction and rollback all changes.","ref":"Mongo.Session.html#abort_transaction/1"},{"type":"function","title":"Mongo.Session.advance_operation_time/2","doc":"Advance the operationTime for causally consistent read commands","ref":"Mongo.Session.html#advance_operation_time/2"},{"type":"function","title":"Mongo.Session.alive?/1","doc":"Check if the session is alive.","ref":"Mongo.Session.html#alive?/1"},{"type":"function","title":"Mongo.Session.bind_session/2","doc":"Merge the session / transaction data into the cmd. There is no need to call this function directly. It is called automatically.","ref":"Mongo.Session.html#bind_session/2"},{"type":"function","title":"Mongo.Session.cast/2","doc":"","ref":"Mongo.Session.html#cast/2"},{"type":"function","title":"Mongo.Session.commit_transaction/1","doc":"Commit the current transaction.","ref":"Mongo.Session.html#commit_transaction/1"},{"type":"function","title":"Mongo.Session.commit_transaction/2","doc":"","ref":"Mongo.Session.html#commit_transaction/2"},{"type":"function","title":"Mongo.Session.connection/1","doc":"Return the connection used in the session.","ref":"Mongo.Session.html#connection/1"},{"type":"function","title":"Mongo.Session.end_session/2","doc":"End explicit session.","ref":"Mongo.Session.html#end_session/2"},{"type":"function","title":"Mongo.Session.handle_call_event/3","doc":"","ref":"Mongo.Session.html#handle_call_event/3"},{"type":"function","title":"Mongo.Session.handle_cast_event/3","doc":"","ref":"Mongo.Session.html#handle_cast_event/3"},{"type":"function","title":"Mongo.Session.in_read_session/3","doc":"","ref":"Mongo.Session.html#in_read_session/3"},{"type":"function","title":"Mongo.Session.in_session/5","doc":"","ref":"Mongo.Session.html#in_session/5"},{"type":"function","title":"Mongo.Session.in_write_session/3","doc":"This function allows nested in_session calls and provides a session if no session exists so far. A provided session lives in the Process dictionary :session or is specified in the opts dictionary.","ref":"Mongo.Session.html#in_write_session/3"},{"type":"function","title":"Mongo.Session.init/6","doc":"","ref":"Mongo.Session.html#init/6"},{"type":"function","title":"Mongo.Session.mark_server_unknown/1","doc":"","ref":"Mongo.Session.html#mark_server_unknown/1"},{"type":"function","title":"Mongo.Session.run_in_transaction/5","doc":"","ref":"Mongo.Session.html#run_in_transaction/5"},{"type":"function","title":"Mongo.Session.select_server/2","doc":"","ref":"Mongo.Session.html#select_server/2"},{"type":"function","title":"Mongo.Session.start_link/6","doc":"Start the generic state machine.","ref":"Mongo.Session.html#start_link/6"},{"type":"function","title":"Mongo.Session.start_session/3","doc":"Start a new session for the topology_pid . You need to specify the type : :read for read and :write for write operations. Example { :ok , session } = Session . start_session ( top , :write , [ ] )","ref":"Mongo.Session.html#start_session/3"},{"type":"function","title":"Mongo.Session.start_transaction/1","doc":"Start a new transaction.","ref":"Mongo.Session.html#start_transaction/1"},{"type":"function","title":"Mongo.Session.update_recovery_token/2","doc":"Update the recoveryToken after each response from mongos","ref":"Mongo.Session.html#update_recovery_token/2"},{"type":"function","title":"Mongo.Session.update_session/3","doc":"Update the operationTime for causally consistent read commands. There is no need to call this function directly. It is called automatically.","ref":"Mongo.Session.html#update_session/3"},{"type":"function","title":"Mongo.Session.wire_version/1","doc":"Return the wire_version used in the session.","ref":"Mongo.Session.html#wire_version/1"},{"type":"function","title":"Mongo.Session.with_transaction/3","doc":"Convenient function for running multiple write commands in a transaction. In case of TransientTransactionError or UnknownTransactionCommitResult the function will retry the whole transaction or the commit of the transaction. You can specify a timeout ( :transaction_retry_timeout_s ) to limit the time of repeating. The default value is 120 seconds. If you don't wait so long, you call with_transaction with the option transaction_retry_timeout_s: 10 . In this case after 10 seconds of retrying, the function will return an error. Example alias Mongo.Session { :ok , ids } = Session . with_transaction ( top , fn opts -&gt; { :ok , % InsertOneResult { :inserted_id =&gt; id1 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , opts ) { :ok , % InsertOneResult { :inserted_id =&gt; id2 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } , opts ) { :ok , % InsertOneResult { :inserted_id =&gt; id3 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } , opts ) { :ok , [ id1 , id2 , id3 ] } end , transaction_retry_timeout_s : 10 ) From the specs: The callback function may be executed multiple times The implementation of with_transaction is based on the original examples for Retry Transactions and Commit Operation from the MongoDB Manual. As such, the callback may be executed any number of times. Drivers are free to encourage their users to design idempotent callbacks.","ref":"Mongo.Session.html#with_transaction/3"},{"type":"type","title":"Mongo.Session.t/0","doc":"","ref":"Mongo.Session.html#t:t/0"},{"type":"module","title":"Mongo.Session.ServerSession","doc":"This module represents the server-side session. There are three fields: last_use - The timestamp for the last use of this server session txn_num - The current transaction number session_id - The session id of this server session When a transaction is active, all operations in that transaction use the same transaction number. Transaction number is also used outside of transactions for retryable writes. In this case, each write operation has its own transaction number, but retries of a write operation use the same transaction number as the first write (which is how the server knows that subsequent writes are retries and should be ignored if the first write succeeded on the server but was not read by the client, for example).","ref":"Mongo.Session.ServerSession.html"},{"type":"function","title":"Mongo.Session.ServerSession.about_to_expire?/2","doc":"Return true, if the server session will time out. In this case the session can be removed from the queue.","ref":"Mongo.Session.ServerSession.html#about_to_expire?/2"},{"type":"function","title":"Mongo.Session.ServerSession.new/0","doc":"Create a new server session.","ref":"Mongo.Session.ServerSession.html#new/0"},{"type":"function","title":"Mongo.Session.ServerSession.next_txn_num/1","doc":"Increment the current transaction number and return the new value.","ref":"Mongo.Session.ServerSession.html#next_txn_num/1"},{"type":"function","title":"Mongo.Session.ServerSession.set_last_use/1","doc":"Update the last_use attribute of the server session to now.","ref":"Mongo.Session.ServerSession.html#set_last_use/1"},{"type":"type","title":"Mongo.Session.ServerSession.t/0","doc":"","ref":"Mongo.Session.ServerSession.html#t:t/0"},{"type":"module","title":"Mongo.Session.SessionPool","doc":"A FIFO cache for sessions. To get a new session, call checkout . This returns a new session or a cached session. After running the operation call checkin(session) to put the session into the FIFO cache for reuse. The MongoDB specifications allows to generate the uuid from the client. That means, that we can just create server sessions and use them for logicial sessions. If they expire then we drop these sessions, otherwise we can reuse the server sessions.","ref":"Mongo.Session.SessionPool.html"},{"type":"function","title":"Mongo.Session.SessionPool.checkin/2","doc":"Checkin a used server session. It if is already expired, the server session is dropped. Otherwise the server session is cache for reuse, until it expires due of being cached all the time.","ref":"Mongo.Session.SessionPool.html#checkin/2"},{"type":"function","title":"Mongo.Session.SessionPool.checkout/1","doc":"Return a server session. If the session timeout is not reached, then a cached server session is return for reuse. Otherwise a newly created server session is returned.","ref":"Mongo.Session.SessionPool.html#checkout/1"},{"type":"function","title":"Mongo.Session.SessionPool.new/2","doc":"","ref":"Mongo.Session.SessionPool.html#new/2"},{"type":"type","title":"Mongo.Session.SessionPool.session_pool/0","doc":"","ref":"Mongo.Session.SessionPool.html#t:session_pool/0"},{"type":"module","title":"Mongo.StreamingHelloMonitor","doc":"See https://github.com/mongodb/specifications/blob/master/source/server-discovery-and-monitoring/server-monitoring.rst#streaming-protocol The streaming protocol is used to monitor MongoDB 4.4+ servers and optimally reduces the time it takes for a client to discover server state changes. Multi-threaded or asynchronous drivers MUST use the streaming protocol when connected to a server that supports the awaitable hello or legacy hello commands. This protocol requires an extra thread and an extra socket for each monitor to perform RTT calculations. This module implements the streaming protocol. The GenServer is started and maintained by the Monitor process. The streaming hello monitor uses the more to come flag while updating the current server description.","ref":"Mongo.StreamingHelloMonitor.html"},{"type":"function","title":"Mongo.StreamingHelloMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mongo.StreamingHelloMonitor.html#child_spec/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.connected/2","doc":"Report the connection event, so the topology process can now create the connection pool.","ref":"Mongo.StreamingHelloMonitor.html#connected/2"},{"type":"function","title":"Mongo.StreamingHelloMonitor.handle_cast/2","doc":"Time to update the topology. Calling hello and updating the server description","ref":"Mongo.StreamingHelloMonitor.html#handle_cast/2"},{"type":"function","title":"Mongo.StreamingHelloMonitor.info/1","doc":"","ref":"Mongo.StreamingHelloMonitor.html#info/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.init/1","doc":"Initialize the monitor process","ref":"Mongo.StreamingHelloMonitor.html#init/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.start_link/1","doc":"","ref":"Mongo.StreamingHelloMonitor.html#start_link/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.terminate/2","doc":"In this case we stop the DBConnection.","ref":"Mongo.StreamingHelloMonitor.html#terminate/2"},{"type":"module","title":"Mongo.UnorderedBulk","doc":"An unordered bulk is filled in the memory with the bulk operations. These are divided into three lists (inserts, updates, deletes) added. If the unordered bulk is written to the database, the groups are written in the following order: inserts updates deletes The order within the group is undefined. Example alias Mongo.UnorderedBulk alias Mongo.BulkWrite bulk = &quot;bulk&quot; |&gt; UnorderedBulk . new ( ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Greta&quot; } ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Tom&quot; } ) |&gt; UnorderedBulk . insert_one ( %{ name : &quot;Waldo&quot; } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Greta&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Tom&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) |&gt; UnorderedBulk . delete_one ( %{ kind : &quot;dog&quot; } ) result = BulkWrite . write ( :mongo , bulk , w : 1 ) To reduce the memory usage the unordered bulk can be used with streams. Example 1 .. 1_000_000 |&gt; Stream . map ( fn i -&gt; BulkOps . get_insert_one ( %{ number : i } ) end ) |&gt; UnorderedBulk . write ( :mongo , &quot;bulk&quot; , 1_000 ) |&gt; Stream . run ( ) This example first generates the bulk operation by calling Mongo.BulkOps.get_insert_one\\1 . The operation is used as a parameter in the Mongo.UnorderedBulk.write\\3 function. The unordered bulk was created with a buffer of 1000 operations. After 1000 operations, the unordered bulk is written to the database. Depending on the selected size you can control the speed and memory consumption. The higher the value, the faster the processing and the greater the memory consumption.","ref":"Mongo.UnorderedBulk.html"},{"type":"function","title":"Mongo.UnorderedBulk.add/2","doc":"Adds the two unordered bulks together.","ref":"Mongo.UnorderedBulk.html#add/2"},{"type":"function","title":"Mongo.UnorderedBulk.delete_many/2","doc":"Appends a delete operation with :limit = 0 . Example: Mongo.UnorderedBulk . delete_many ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ { %{ name : &quot;Waldo&quot; } , [ limit : 0 ] } ] , inserts : [ ] , updates : [ ] }","ref":"Mongo.UnorderedBulk.html#delete_many/2"},{"type":"function","title":"Mongo.UnorderedBulk.delete_one/2","doc":"Appends a delete operation with :limit = 1 . Example: Mongo.UnorderedBulk . delete_one ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ { %{ name : &quot;Waldo&quot; } , [ limit : 1 ] } ] , inserts : [ ] , updates : [ ] }","ref":"Mongo.UnorderedBulk.html#delete_one/2"},{"type":"function","title":"Mongo.UnorderedBulk.empty?/1","doc":"Returns true, if the bulk is empty, that means it contains no inserts, updates or deletes operations","ref":"Mongo.UnorderedBulk.html#empty?/1"},{"type":"function","title":"Mongo.UnorderedBulk.insert_one/2","doc":"Appends an insert operation. Example: Mongo.UnorderedBulk . insert_one ( bulk , %{ name : &quot;Waldo&quot; } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ ] , inserts : [ %{ name : &quot;Waldo&quot; } ] , updates : [ ] }","ref":"Mongo.UnorderedBulk.html#insert_one/2"},{"type":"function","title":"Mongo.UnorderedBulk.new/1","doc":"Creates an empty unordered bulk for a collection. Example: Mongo.UnorderedBulk . new ( &quot;bulk&quot; ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ ] , inserts : [ ] , updates : [ ] }","ref":"Mongo.UnorderedBulk.html#new/1"},{"type":"function","title":"Mongo.UnorderedBulk.push/2","doc":"Appends a bulk operation to the unordered bulk. One of the field (inserts, updates or deletes) will be updated.","ref":"Mongo.UnorderedBulk.html#push/2"},{"type":"function","title":"Mongo.UnorderedBulk.replace_one/4","doc":"Appends a replace operation with :multi = false . Example: Mongo.UnorderedBulk . replace_one ( bulk , %{ name : &quot;Waldo&quot; } , %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ ] , inserts : [ ] , updates : [ { %{ name : &quot;Waldo&quot; } , %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } , [ multi : false ] } ] }","ref":"Mongo.UnorderedBulk.html#replace_one/4"},{"type":"function","title":"Mongo.UnorderedBulk.update_many/4","doc":"Appends a update operation with :multi = true . Example: Mongo.UnorderedBulk . update_many ( bulk , %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ ] , inserts : [ ] , updates : [ { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : true ] } ] }","ref":"Mongo.UnorderedBulk.html#update_many/4"},{"type":"function","title":"Mongo.UnorderedBulk.update_one/4","doc":"Appends a update operation with :multi = false . Example: Mongo.UnorderedBulk . update_one ( bulk , %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ name : &quot;Greta&quot; , kind : &quot;dog&quot; } } ) % Mongo.UnorderedBulk { coll : &quot;bulk&quot; , deletes : [ ] , inserts : [ ] , updates : [ { %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; , name : &quot;Greta&quot; } } , [ multi : false ] } ] }","ref":"Mongo.UnorderedBulk.html#update_one/4"},{"type":"function","title":"Mongo.UnorderedBulk.write/5","doc":"Returns a stream chunk function that can be used with streams. The limit specifies the number of operation hold in the memory while processing the stream inputs. The inputs of the stream should be Mongo.BulkOps.bulk_op . See Mongo.BulkOps","ref":"Mongo.UnorderedBulk.html#write/5"},{"type":"type","title":"Mongo.UnorderedBulk.t/0","doc":"","ref":"Mongo.UnorderedBulk.html#t:t/0"},{"type":"module","title":"Mongo.UpdateResult","doc":"The successful result struct of Mongo.update_one/5 , Mongo.update_many/5 and Mongo.replace_one/5 . Its fields are: :matched_count - Number of matched documents :modified_count - Number of modified documents :upserted_ids - If the operation was an upsert, the upserted ids","ref":"Mongo.UpdateResult.html"},{"type":"type","title":"Mongo.UpdateResult.t/0","doc":"","ref":"Mongo.UpdateResult.html#t:t/0"},{"type":"module","title":"Mongo.UrlParser","doc":"Mongo connection URL parsing util See for the complete list of options.","ref":"Mongo.UrlParser.html"},{"type":"function","title":"Mongo.UrlParser.parse_url/1","doc":"","ref":"Mongo.UrlParser.html#parse_url/1"},{"type":"module","title":"Mongo.Version","doc":"This module contains the constant of all wire versions. see https://github.com/mongodb/mongo/blob/master/src/mongo/db/wire_version.h","ref":"Mongo.Version.html"},{"type":"function","title":"Mongo.Version.decode/1","doc":"","ref":"Mongo.Version.html#decode/1"},{"type":"function","title":"Mongo.Version.encode/1","doc":"","ref":"Mongo.Version.html#encode/1"},{"type":"exception","title":"Mongo.Error","doc":"","ref":"Mongo.Error.html"},{"type":"function","title":"Mongo.Error.fail_command?/1","doc":"Returns true if the error is issued by the failCommand","ref":"Mongo.Error.html#fail_command?/1"},{"type":"function","title":"Mongo.Error.has_label/2","doc":"","ref":"Mongo.Error.html#has_label/2"},{"type":"function","title":"Mongo.Error.not_primary_no_secondary_ok?/1","doc":"","ref":"Mongo.Error.html#not_primary_no_secondary_ok?/1"},{"type":"function","title":"Mongo.Error.not_primary_or_secondary?/1","doc":"","ref":"Mongo.Error.html#not_primary_or_secondary?/1"},{"type":"function","title":"Mongo.Error.not_writable_primary?/1","doc":"","ref":"Mongo.Error.html#not_writable_primary?/1"},{"type":"function","title":"Mongo.Error.not_writable_primary_or_recovering?/2","doc":"Return true if the error == not writable primary or in recovering mode.","ref":"Mongo.Error.html#not_writable_primary_or_recovering?/2"},{"type":"function","title":"Mongo.Error.should_retry_read/3","doc":"Return true if the error is retryable for read operations.","ref":"Mongo.Error.html#should_retry_read/3"},{"type":"function","title":"Mongo.Error.should_retry_write/3","doc":"Return true if the error is retryable for writes operations.","ref":"Mongo.Error.html#should_retry_write/3"},{"type":"type","title":"Mongo.Error.t/0","doc":"","ref":"Mongo.Error.html#t:t/0"},{"type":"exception","title":"Mongo.WriteError","doc":"","ref":"Mongo.WriteError.html"},{"type":"function","title":"Mongo.WriteError.message/1","doc":"Callback implementation for Exception.message/1 .","ref":"Mongo.WriteError.html#message/1"},{"type":"type","title":"Mongo.WriteError.t/0","doc":"","ref":"Mongo.WriteError.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - 1.2.0 (2023-08-30)","doc":"Features Supports passing arrayFilters option through find_one_and_update ( #201 ) ( 082878b ) Bug Fixes fixed typo ( e6eff31 )","ref":"changelog.html#1-2-0-2023-08-30"},{"type":"extras","title":"Changelog - 1.1.0 (2023-07-30)","doc":"Features add support for Elixir 1.15 ( #195 ) ( f621a62 )","ref":"changelog.html#1-1-0-2023-07-30"},{"type":"extras","title":"Changelog - 1.0.3 (2023-05-13)","doc":"Bug Fixes check if monitor pid exists before stopping ( 6e0c8b2 ) Enhancements Add support of errInfo ( #187 ) add support for the hint option ( #175 ) ( 4c817b7 ) add telemetry start event to fix #174 ( e79db9e )","ref":"changelog.html#1-0-3-2023-05-13"},{"type":"extras","title":"Changelog - 1.0.2 (2023-01-02)","doc":"Bug Fixes deprecated 'use Bitwise' ( #168 ) ( a980d57 ) use the basename of the file path ( 3a10c56 )","ref":"changelog.html#1-0-2-2023-01-02"},{"type":"extras","title":"Changelog - 1.0.1 (2022-12-17)","doc":"Bug Fixes replace :code.priv_dir/1 function ( da0fd6c )","ref":"changelog.html#1-0-1-2022-12-17"},{"type":"extras","title":"Changelog - 1.0.0 (2022-11-27)","doc":"Bug Fixes add migration ( da65de4 ) remove a bug in the hello handshake protocol (thanks to fireproofsocks for reporting) ( 59aa841 ) remove derived attributes in the dump function ( c1b60b4 ) Enhancements improve the dump and load functions ( #154 ) ( e7f2d44 ) use the same timestamps in new/0 function ( 0db61da ) Miscellaneous Chores release 1.0.0 ( 64e274a )","ref":"changelog.html#1-0-0-2022-11-27"},{"type":"extras","title":"Changelog - 0.9.3 (2022-10-14)","doc":"Bugfix fix a bug in the hello handshake protocol (thanks to fireproofsocks for reporting) Enhancements add migration","ref":"changelog.html#0-9-3-2022-10-14"},{"type":"extras","title":"Changelog - 0.9.2 (2022-09-24)","doc":"Bugfix fix a crash in the streaming hello monitor, if the server sends more than one response at once add support for the new hello handshake refactor :timeout option (thanks to JD-Robertson for reporting) add timestamps macro to the collection module to handle inserted_at and updated_at attributes (thanks to carlosliracl)","ref":"changelog.html#0-9-2-2022-09-24"},{"type":"extras","title":"Changelog - 0.9.1 (2022-05-27)","doc":"Bugfix add backward compatible for Elixir &lt; 1.13 (thanks to ja-jimenez)","ref":"changelog.html#0-9-1-2022-05-27"},{"type":"extras","title":"Changelog - 0.9.0 (2022-05-21)","doc":"Enhancements add colored log output add telemetry support for execution add new Repo module (thanks to daskycodes) add missing typespecs (thanks to fdie) refactor transaction api to support nested transaction add Mongo.rename_collection/3 command","ref":"changelog.html#0-9-0-2022-05-21"},{"type":"extras","title":"Changelog - 0.8.4 (2022-03-09)","doc":"Bugfix add missing excludes from dump function (collections)","ref":"changelog.html#0-8-4-2022-03-09"},{"type":"extras","title":"Changelog - 0.8.3 (2022-02-17)","doc":"Bugfix fix no function clause matching (thanks to bodbdigr)","ref":"changelog.html#0-8-3-2022-02-17"},{"type":"extras","title":"Changelog - 0.8.2 (2022-02-03)","doc":"Enhancements Remove a compiler warning (thanks to a-jimenez )","ref":"changelog.html#0-8-2-2022-02-03"},{"type":"extras","title":"Changelog - 0.8.1 (2022-01-22)","doc":"Enhancements Fix for serializing BSON Regex without options (thanks to MillionIntegrals) Misc doc changes (thanks to kianmeng) Added support for OP_MSG exhaustAllowed flag Added support for streaming protocol Added Insights app for development ]()","ref":"changelog.html#0-8-1-2022-01-22"},{"type":"extras","title":"Changelog - 0.8.0 (2021-11-07) (0.7.5 was not published)","doc":"Enhancements replica set connection: faster topology update if the primary is down (thanks to p-mongo) added custom Mongo.Encoder protocol (thanks to esse) added collection from yildun project fixed an issue that the bulk operation does not stop after any insert/update/delete failed (thanks to ja-jimenez)","ref":"changelog.html#0-8-0-2021-11-07-0-7-5-was-not-published"},{"type":"extras","title":"Changelog - 0.7.4 (2021-06-21)","doc":"Enhancements added a new option to specify a timeout, when increasing the connection pool is no option","ref":"changelog.html#0-7-4-2021-06-21"},{"type":"extras","title":"Changelog - 0.7.3 (2021-05-29)","doc":"Enhancements added support for OTP 24 Add support for tls setting in connection string (tschmittni) Replace deprecated functions (OTP 24) (aenglisc )","ref":"changelog.html#0-7-3-2021-05-29"},{"type":"extras","title":"Changelog - 0.7.2 (2021-05-19)","doc":"Enhancements Adds test to cover one of Mongo.find/4 errors (vukanac) Update specs for Mongo.find/4 with error tuple (vukanac) Fix build warnings and correct typespec (joeapearson) Update db_connection version to remove System.stacktrace warnings (vukanac) Update SCRAM auth procedure (LetThereBeDwight)","ref":"changelog.html#0-7-2-2021-05-19"},{"type":"extras","title":"Changelog - 0.7.1 (2021-01-01)","doc":"Enhancements upgraded decimal to 2.0, jason to 1.2 Add proper support for tailable cursors and awaitData (PR #74)","ref":"changelog.html#0-7-1-2021-01-01"},{"type":"extras","title":"Changelog - 0.7.0 (2020-04-17)","doc":"Enhancements refactored event notification system added support for retryable reads and writes refactored the test cases now using mtools for a MongoDB deployment in the travis ci environment travis ci uses only the latest MongoDB version The failCommand Session.commit_transaction returns now :ok or an error {:error, %Mongo.Error{}} Bugfixes Using max_staleness_ms &gt; 0 results in a crash Read preferences are sent to mongos","ref":"changelog.html#0-7-0-2020-04-17"},{"type":"extras","title":"Changelog - 0.6.5 (2020-03-30)","doc":"Enhancements updated db_connection dependency generalize inconsistent typespecs new function BSON.ObjectId.decode/1 and BSON.ObjectId.encode/1 new function Mongo.uuid/1","ref":"changelog.html#0-6-5-2020-03-30"},{"type":"extras","title":"Changelog - 0.6.4 (2020-01-24)","doc":"Bugfixes fixed bug in Mongo.TopologyDescription in case of a shard cluster deployment (#39)","ref":"changelog.html#0-6-4-2020-01-24"},{"type":"extras","title":"Changelog - 0.6.3 (2020-01-23)","doc":"Enhancements basic support for inserting structs removed duplicated code Cursor-API raises a Mongo.Error instead of a FunctionClauseError Bugfixes :appname option (typo) #38 fixed index creation in Mongo.GridFs.Bucket","ref":"changelog.html#0-6-3-2020-01-23"},{"type":"extras","title":"Changelog - 0.6.2 (2019-11-15)","doc":"Enhancements refactored the api of Mongo.limits and Mongo.wire_version add support for tracking recovery token from response in a sharded transaction","ref":"changelog.html#0-6-2-2019-11-15"},{"type":"extras","title":"Changelog - 0.6.1 (2019-11-01)","doc":"Enhancements refactored Mongo.Session and Mongo.Session.SessionPool because of poor performance","ref":"changelog.html#0-6-1-2019-11-01"},{"type":"extras","title":"Changelog - 0.6.0 (2019-09-18)","doc":"Enhancements refactored writeConcern refactored filter_nils refactored usage of ReadPreference added support for sessions ( ServerSession , SessionPool , Session ) added support for transaction added Decimal128 encoder added support for transaction to gridfs and bulk operation added create command (explicitly creating a collection or view)","ref":"changelog.html#0-6-0-2019-09-18"},{"type":"extras","title":"Changelog - 0.5.7 (2019-06-25)","doc":"Bug Fixes Test for existing index in Bucket works right now Enhancements Better handling for the :timeout options","ref":"changelog.html#0-5-7-2019-06-25"},{"type":"extras","title":"Changelog - 0.5.6 (2019-06-14)","doc":"Bug Fixes Fixed a match error in after_fun of cursor module Fixed a match error in the result of function Monitor.force_check Resolved decode problem for the Binary (Old) BinData subtype Enhancements Added support for Mongo.BulkWriteResult","ref":"changelog.html#0-5-6-2019-06-14"},{"type":"extras","title":"Changelog - 0.5.5 (2019-05-22)","doc":"Bug Fixes Fixed a match error when using Windows OS","ref":"changelog.html#0-5-5-2019-05-22"},{"type":"extras","title":"Changelog - 0.5.4 (2019-05-21)","doc":"Enhancements The driver provides now client metadata Added support for connecting via UNIX sockets ( :socket and :socket_dir ) Added support for bulk writes (ordered/unordered, in-memory/stream) Added support for op_msg with payload type 1 Merged code from https://github.com/ankhers/mongodb/commit/63c20ff7e427744a5df915751adfaf6e5e39ae62 Merged changes from https://github.com/ankhers/mongodb/pull/283 Merged changes from https://github.com/ankhers/mongodb/pull/281","ref":"changelog.html#0-5-4-2019-05-21"},{"type":"extras","title":"Changelog - 0.5.3 (2019-05-02)","doc":"Enhancements Travis now using the right MongoDB version Bug Fixes Added test unit for change streams Removed debug code from change streams","ref":"changelog.html#0-5-3-2019-05-02"},{"type":"extras","title":"Changelog - 0.5.2 (2019-05-01)","doc":"Enhancements Added op_msg support ( See ) Fixed change streams in case of error codes: 11601, 136 and 237 from resuming Reorganized error handling","ref":"changelog.html#0-5-2-2019-05-01"},{"type":"extras","title":"Changelog - 0.5.1 (2019-04-28)","doc":"Enhancements Upgraded to DBConnection 2.0.6 Refactored code, simplified code and api Replaced deprecated op_code by database commands Update_one, update_many, replace_one, replace_many return upserted ids Add support for all find options Add support for MongoDB 3.6 collection Change Streams Ass support for SCRAM-SHA-256 (MongoDB 4.x)","ref":"changelog.html#0-5-1-2019-04-28"},{"type":"extras","title":"Changelog - 0.4.8-dev","doc":"Enhancements Added hostname and port to exceptions Added support for x509 authentication Allow passing only partial read_preference information Add support for GridFS Bug Fixes Fixed a connection leak Properly parse write concern for URL Properly follow read preference for secondary_preferred","ref":"changelog.html#0-4-8-dev"},{"type":"extras","title":"Changelog - v0.4.7 (2018-09-13)","doc":"Enhancements Added 4.0 to supported versions Initial support for mongodb+srv URLs Support for Decimal128","ref":"changelog.html#v0-4-7-2018-09-13"},{"type":"extras","title":"Changelog - v0.4.6 (2018-05-20)","doc":"Enhancements Added :connect_timout_ms to Mongo.start_link/1 Reorganized documentation","ref":"changelog.html#v0-4-6-2018-05-20"},{"type":"extras","title":"Changelog - 0.4.5 (2018-04-08)","doc":"Enhancements Should now be able to send a query to your server before the connection is fully made Bug Fixes Should actually be able to query for longer than 5 seconds","ref":"changelog.html#0-4-5-2018-04-08"},{"type":"extras","title":"Changelog - 0.4.4 (2018-02-09)","doc":"Enhancements Added support for using a mongo url via the :url key Added MongoDB 3.6 to supported versions Added support for the deprecated undefined BSON type Bug Fixes Added another case for BSON NaN Fixed encoding and decoding of the BSON Timestamp type Should now figure out Topology for replica sets even if you exclude the :type key Fixed an issue where our monitors would become empty, preventing the driver from reconnecting to a downed database","ref":"changelog.html#0-4-4-2018-02-09"},{"type":"extras","title":"Changelog - 0.4.3 (2017-09-16)","doc":"Enhancements Send TLS server name indication (SNI) if none is set in the :ssl_opts Fixed a couple dialyzer issues Add basic examples of $and , $or , and $in operators in README Bug Fixes Ensure cursor requests are routed to the proper node in the cluster No longer attempting to authenticate against arbiter nodes Prevent monitor errors if you have stopped the mongo process","ref":"changelog.html#0-4-3-2017-09-16"},{"type":"extras","title":"Changelog - 0.4.2 (2017-08-28)","doc":"Bug fixes Fix application crash when a replica set member goes offline Fix application crash on start when a replica set member is offline","ref":"changelog.html#0-4-2-2017-08-28"},{"type":"extras","title":"Changelog - 0.4.1 (2017-08-09)","doc":"Bug fixes Monitors no longer use a pool Can now connect to a Mongo instance using a CNAME Pass options through Mongo.aggregate/4","ref":"changelog.html#0-4-1-2017-08-09"},{"type":"extras","title":"Changelog - 0.4.0 (2017-06-07)","doc":"Replica Set Support","ref":"changelog.html#0-4-0-2017-06-07"},{"type":"extras","title":"Changelog - 0.3.0 (2017-05-11)","doc":"Breaking changes Remove BSON.DateTime and replace it with native Elixir DateTime","ref":"changelog.html#0-3-0-2017-05-11"},{"type":"extras","title":"Changelog - 0.2.1 (2017-05-08)","doc":"Enhancements SSL support Add functions BSON.DateTime.to_elixir_datetime/1 and BSON.DateTime.from_elixir_datetime/1 Changes Requires Elixir ~&gt; 1.3","ref":"changelog.html#0-2-1-2017-05-08"},{"type":"extras","title":"Changelog - 0.2.0 (2016-11-11)","doc":"Enhancements Add BSON.ObjectID.encode!/1 and BSON.ObjectID.decode!/1 Optimize and reduce binary copying Add tuple/raising versions of functions in Mongo Add :inserted_count field to Mongo.InsertManyResult Support NaN and infinite numbers in bson float encode/decode Add Mongo.object_id/0 for generating objectids Add Mongo.child_spec/2 Add Mongo.find_one_and_update/5 Add Mongo.find_one_and_replace/5 Add Mongo.find_one_and_delete/4 Bug fixes Fix float endianness Breaking changes Switched to using db_connection library, see the current docs for changes","ref":"changelog.html#0-2-0-2016-11-11"},{"type":"extras","title":"Changelog - 0.1.1 (2015-12-17)","doc":"Enhancements Add BSON.DateTime.from_datetime/1 Bug fixes Fix timestamp epoch in generated object ids Fix Mongo.run_command/3 to accept errors without code","ref":"changelog.html#0-1-1-2015-12-17"},{"type":"extras","title":"Changelog - 0.1.0 (2015-08-25)","doc":"Initial release","ref":"changelog.html#0-1-0-2015-08-25"},{"type":"extras","title":"License","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html"},{"type":"extras","title":"Overview","doc":"","ref":"readme.html"},{"type":"extras","title":"Overview - Features","doc":"supports MongoDB versions 4.x, 5.x, 6.x connection pooling ( through DBConnection 2.x ) streaming cursors performant ObjectID generation aggregation pipeline replica sets support for SCRAM-SHA-256 (MongoDB 4.x) support for GridFS ( See ) support for change streams api ( See ) support for bulk writes ( See ) support for driver sessions ( See ) support for driver transactions ( See ) support for command monitoring ( See ) support for retryable reads ( See ) support for retryable writes ( See ) support for simple structs using the Mongo.Encoder protocol support for complex and nested documents using the Mongo.Collection macros support for streaming protocol ( See ) support for migration scripts","ref":"readme.html#features"},{"type":"extras","title":"Overview - Usage","doc":"Installation Add mongodb_driver to your mix.exs deps . defp deps do [ { :mongodb_driver , &quot;~&gt; 1.0.0&quot; } ] end Then run mix deps.get to fetch dependencies. Simple Connection to MongoDB # Starts an unpooled connection { :ok , conn } = Mongo . start_link ( url : &quot;mongodb://localhost:27017/my-database&quot; ) # Gets an enumerable cursor for the results cursor = Mongo . find ( conn , &quot;test-collection&quot; , %{ } ) cursor |&gt; Enum . to_list ( ) |&gt; IO . inspect To specify a username and password, use the :username , :password , and :auth_source options. # Starts an unpooled connection { :ok , conn } = Mongo . start_link ( url : &quot;mongodb://localhost:27017/db-name&quot; , username : &quot;test_user&quot; , password : &quot;hunter2&quot; , auth_source : &quot;admin_test&quot; ) # Gets an enumerable cursor for the results cursor = Mongo . find ( conn , &quot;test-collection&quot; , %{ } ) cursor |&gt; Enum . to_list ( ) |&gt; IO . inspect For secure requests, you may need to add some more options; see the &quot;AWS, TLS and Erlang SSL ciphers&quot; section below. Failing operations return a {:error, error} tuple where error is a Mongo.Error object: { :error , % Mongo.Error { code : 13435 , error_labels : [ ] , host : nil , message : &quot;not master and slaveOk=false&quot; , resumable : true , retryable_reads : true , retryable_writes : true } }","ref":"readme.html#usage"},{"type":"extras","title":"Overview - Examples","doc":"Find Using $and Mongo . find ( :mongo , &quot;users&quot; , %{ &quot;$and&quot; =&gt; [ %{ email : &quot;my@email.com&quot; } , %{ first_name : &quot;first_name&quot; } ] } ) Using $or Mongo . find ( :mongo , &quot;users&quot; , %{ &quot;$or&quot; =&gt; [ %{ email : &quot;my@email.com&quot; } , %{ first_name : &quot;first_name&quot; } ] } ) Using $in Mongo . find ( :mongo , &quot;users&quot; , %{ email : %{ &quot;$in&quot; =&gt; [ &quot;my@email.com&quot; , &quot;other@email.com&quot; ] } } ) Inserts To insert a single document: Mongo . insert_one ( top , &quot;users&quot; , %{ first_name : &quot;John&quot; , last_name : &quot;Smith&quot; } ) To insert a list of documents: Mongo . insert_many ( top , &quot;users&quot; , [ %{ first_name : &quot;John&quot; , last_name : &quot;Smith&quot; } , %{ first_name : &quot;Jane&quot; , last_name : &quot;Doe&quot; } ] )","ref":"readme.html#examples"},{"type":"extras","title":"Overview - Data Representation","doc":"Since BSON documents are ordered Elixir maps cannot be used to fully represent them. This driver chose to accept both maps and lists of key-value pairs when encoding but will only decode documents to lists. This has the side-effect that it's impossible to discern empty arrays from empty documents. Additionally, the driver will accept both atoms and strings for document keys but will only decode to strings. BSON symbols can only be decoded. BSON Elixir -- -- -- -- -- -- -- -- double 0.0 string &quot;Elixir&quot; document [ { &quot;key&quot; , &quot;value&quot; } ] | %{ &quot;key&quot; =&gt; &quot;value&quot; } ( 1 ) binary % BSON.Binary { binary : &lt;&lt; 42 , 43 &gt;&gt; , subtype : :generic } UUID % BSON.Binary { binary : &lt;&lt; 42 , 43 &gt;&gt; , subtype : :uuid } UUID ( old style ) % BSON.Binary { binary : &lt;&lt; 42 , 43 &gt;&gt; , subtype : :uuid_old } object id % BSON.ObjectId { value : &lt;&lt; ... &gt;&gt; } boolean true | false UTC datetime % DateTime { } null nil regex % BSON.Regex { pattern : &quot;...&quot; } JavaScript % BSON.JavaScript { code : &quot;...&quot; } timestamp # BSON.Timestamp &lt; value :ordinal &gt; &quot; integer 32 42 integer 64 #BSON.LongNumber&lt;value&gt; symbol &quot; foo &quot; ( 2 ) min key :BSON_min max key :BSON_max decimal128 Decimal { }","ref":"readme.html#data-representation"},{"type":"extras","title":"Overview - Writing your own encoding info","doc":"If you want to write a custom struct to your mongo collection - you can do that by implementing Mongo.Encoder protocol for your module. The output should be a map, which will be passed to the Mongo database. Example: defmodule CustomStruct do @fields [ :a , :b , :c , :id ] @enforce_keys @fields defstruct @fields defimpl Mongo.Encoder do def encode ( %{ a : a , b : b , id : id } ) do %{ _id : id , a : a , b : b , custom_encoded : true } end end end So, given the struct: % CustomStruct { a : 10 , b : 20 , c : 30 , id : &quot;5ef27e73d2a57d358f812001&quot; } it will be written to database, as: { &quot;a&quot;: 10, &quot;b&quot;: 20, &quot;custom_encoded&quot;: true, &quot;_id&quot;: &quot;5ef27e73d2a57d358f812001&quot; }","ref":"readme.html#writing-your-own-encoding-info"},{"type":"extras","title":"Overview - Collections","doc":"While using the Mongo.Encoder protocol give you the possibility to encode your structs into maps the opposite way to decode those maps into structs is missing. To handle it you can use the Mongo.Collection which provides some boilerplate code for a better support of structs while using the MongoDB driver automatic load and dump function reflection functions type specification support for embedding one and many structs support for after load function support for before dump function support for id generation support for default values support for derived values support for alias attribute names But in the case of queries and updates, a rewrite of the attribute names does not take place. It is still up to you to use the correct attribute names. When using the MongoDB driver only maps and keyword lists are used to represent documents. If you prefer to use structs instead of the maps to give the document a stronger meaning or to emphasize its importance, you have to create a defstruct and fill it from the map manually: defmodule Label do defstruct name : &quot;warning&quot; , color : &quot;red&quot; end iex&gt; label_map = Mongo . find_one ( :mongo , &quot;labels&quot; , %{ } ) %{ &quot;name&quot; =&gt; &quot;warning&quot; , &quot;color&quot; =&gt; &quot;red&quot; } iex&gt; label = % Label { name : label_map [ &quot;name&quot; ] , color : label_map [ &quot;color&quot; ] } We have defined a module Label as defstruct , then we get the first label document the collection labels . The function find_one returns a map. We convert the map manually and get the desired struct. If we want to save a new structure, we have to do the reverse. We convert the struct into a map: iex&gt; label = % Label { } iex&gt; label_map = %{ &quot;name&quot; =&gt; label . name , &quot;color&quot; =&gt; label . color } iex&gt; { :ok , _ } = Mongo . insert_one ( :mongo , &quot;labels&quot; , label_map ) Alternatively, you can also remove the __struct__ key from label . The MongoDB driver automatically converts the atom keys into strings (Or use the Mongo.Encode protocol) iex&gt; Map . drop ( label , [ :__struct__ ] ) %{ color : :red , name : &quot;warning&quot; } If you use nested structures, the work becomes a bit more complex. In this case, you have to use the inner structures convert manually, too. If you take a closer look at the necessary work, two basic functions can be derived: load Conversion of the map into a struct. dump Conversion of the struct into a map. Mongo.Collection provides the necessary macros to automate this boilerplate code. The above example can be rewritten as follows: defmodule Label do use Mongo.Collection document do attribute :name , String . t ( ) , default : &quot;warning&quot; attribute :color , String . t ( ) , default : :red end end This results in the following module: defmodule Label do defstruct [ name : &quot;warning&quot; , color : &quot;red&quot; ] @type t ( ) :: % Label { String . t ( ) , String . t ( ) } def new ( ) ... def load ( map ) ... def dump ( % Label { } ) ... def __collection__ ( :attributes ) ... def __collection__ ( :types ) ... def __collection__ ( :collection ) ... def __collection__ ( :id ) ... end You can now create new structs with the default values and use the conversion functions between map and structs: iex(1)&gt; x = Label . new ( ) % Label { color : :red , name : &quot;warning&quot; } iex(2)&gt; m = Label . dump ( x ) %{ color : :red , name : &quot;warning&quot; } iex(3)&gt; Label . load ( m , true ) % Label { color : :red , name : &quot;warning&quot; } The load/2 function distinguishes between keys of type binarys load(map, false) and keys of type atoms load(map, true) . The default is load(map, false) : iex(1)&gt; m = %{ &quot;color&quot; =&gt; :red , &quot;name&quot; =&gt; &quot;warning&quot; } iex(2)&gt; Label . load ( m ) % Label { color : :red , name : &quot;warning&quot; } If you would now expect atoms as keys, the result of the conversion is not correct in this case: iex(3)&gt; Label . load ( m , true ) % Label { color : nil , name : nil } The background is that MongoDB always returns binarys as keys and structs use atoms as keys. For more information look at the module documentation Mongo.Collection . Of course, using the Mongo.Collection is not free. When loading and saving, the maps are converted into structures, which increases CPU usage somewhat. When it comes to speed, it is better to use the maps directly.","ref":"readme.html#collections"},{"type":"extras","title":"Overview - Breaking changes","doc":"Prior to version 0.9.2 the dump function returns atoms as key. Since the dump/1 function is the inverse function of load/1 , which uses binary keys as default, the dump/1 function should return binary keys as well. This increases the consistency and you can do: l = Label . load ( doc ) doc = Label . dump ( l ) assert l == Label . load ( doc )","ref":"readme.html#breaking-changes"},{"type":"extras","title":"Overview - Using the Repo Module","doc":"For convenience, you can also use the Mongo.Repo module in your application to configure the MongoDB application. Simply create a new module and include the use Mongo.Repo macro: defmodule MyApp.Repo do use Mongo.Repo , otp_app : :my_app , topology : :mongo end To configure the MongoDB add the configuration to your config.exs : config :my_app , MyApp.Repo , url : &quot;mongodb://localhost:27017/my-app-dev&quot; , timeout : 60_000 , idle_interval : 10_000 , queue_target : 5_000 Finally, we can add the Mongo instance to our application supervision tree: children = [ # ... { Mongo , MyApp.Repo . config ( ) } , # ... ] In addition, the convenient configuration, the Mongo.Repo module will also include query functions to use with your Mongo.Collection modules. For more information check out the Mongo.Repo module documentation and the Mongo module documentation.","ref":"readme.html#using-the-repo-module"},{"type":"extras","title":"Overview - Breaking changes","doc":"Prior to version 0.9.2 some Mongo.Repo functions use the dump/1 function for the query (and update) parameter. This worked only for some query that used only the attributes of the document. In the case of nested documents, it didn't work, so it is changed to be more consistent. The Mongo.Repo module is very simple without any query rewriting like Ecto does. In the case you want to use the :name option, you need to specify the query and update documents in the Mongo.Repo functions following the specification in the MongoDB. Example: defmodule MyApp.Session do @moduledoc false use Mongo.Collection alias BSON.Binary collection :s do attribute :uuid , Binary . t ( ) , name : :u end end If you use the Mongo.Repo module and want to fetch a specific session document, this won't work: MyApp.Repo . get_by ( MyApp.Session , %{ uuid : session_uuid } ) because the get_by/2 function uses the query parameter without any rewriting. You need to change the query: MyApp.Repo . get_by ( MyApp.Session , %{ u : session_uuid } ) A rewriting is too complex for now because MongoDB has a lot of options.","ref":"readme.html#breaking-changes"},{"type":"extras","title":"Overview - Logging","doc":"You config the logging output by adding in your config file this line config :mongodb_driver , log : true The attribute log supports true , false or a log level like :info . The default value is false . If you turn logging on, then you will see log output (command, collection, parameters): [ info ] CMD find &quot;my-collection&quot; [ filter : [ name : &quot;Helga&quot; ] ] db = 2.1 ms","ref":"readme.html#logging"},{"type":"extras","title":"Overview - Telemetry","doc":"The driver uses the :telemetry package to emit the execution duration for each command. The event name is [:mongodb_driver, :execution] and the driver uses the following meta data: metadata = %{ type : :mongodb_driver , command : command , params : parameters , collection : collection , options : Keyword . get ( opts , :telemetry_options , [ ] ) } :telemetry . execute ( [ :mongodb_driver , :execution ] , %{ duration : duration } , metadata ) In a Phoenix application with installed Phoenix Dashboard the metrics can be used by defining a metric in the Telemetry module: summary(&quot;mongodb_driver.execution.duration&quot;, tags: [:collection, :command], unit: {:microsecond, :millisecond} ), Then you see for each collection the execution time for each different command in the Dashboard metric page.","ref":"readme.html#telemetry"},{"type":"extras","title":"Overview - Connection Pooling","doc":"The driver supports pooling by DBConnection (2.x). By default mongodb_driver will start a single connection, but it also supports pooling with the :pool_size option. For 3 connections add the pool_size: 3 option to Mongo.start_link and to all function calls in Mongo using the pool: # Starts an pooled connection { :ok , conn } = Mongo . start_link ( url : &quot;mongodb://localhost:27017/db-name&quot; , pool_size : 3 ) # Gets an enumerable cursor for the results cursor = Mongo . find ( conn , &quot;test-collection&quot; , %{ } ) cursor |&gt; Enum . to_list ( ) |&gt; IO . inspect If you're using pooling it is recommended to add it to your application supervisor: def start ( _type , _args ) do import Supervisor.Spec children = [ worker ( Mongo , [ [ name : :mongo , database : &quot;test&quot; , pool_size : 3 ] ] ) ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Due to the mongodb specification, an additional connection is always set up for the monitor process.","ref":"readme.html#connection-pooling"},{"type":"extras","title":"Overview - Replica Sets","doc":"By default, the driver will discover the deployment's topology and will connect to the replica set automatically, using either the seed list syntax or the URI syntax. Assuming the deployment has nodes at hostname1.net:27017 , hostname2.net:27017 and hostname3.net:27017 , either of the following invocations will discover the entire deployment: { :ok , pid } = Mongo . start_link ( database : &quot;test&quot; , seeds : [ &quot;hostname1.net:27017&quot; ] ) { :ok , pid } = Mongo . start_link ( url : &quot;mongodb://hostname1.net:27017/test&quot; ) To ensure that the connection succeeds even when some of the nodes are not available, it is recommended to list all nodes in both the seed list and the URI, as follows: { :ok , pid } = Mongo . start_link ( database : &quot;test&quot; , seeds : [ &quot;hostname1.net:27017&quot; , &quot;hostname2.net:27017&quot; , &quot;hostname3.net:27017&quot; ] ) { :ok , pid } = Mongo . start_link ( url : &quot;mongodb://hostname1.net:27017,hostname2.net:27017,hostname3.net:27017/test&quot; ) Using an SRV URI also discovers all nodes of the deployment automatically.","ref":"readme.html#replica-sets"},{"type":"extras","title":"Overview - Migration","doc":"Despite the schema-free approach, migration is still desirable. Migrations are used to maintain the indexes and to drop collections that are no longer needed. Capped collections must be migrated. The driver provides a workflow similar to Ecto that can be used to create migrations. First we create a migration script: mix mongo . gen . migration add_indexes In priv/mongo/migrations you will find an Elixir script like 20220322173354_add_indexes.exs : defmodule Mongo.Migrations.AddIndexes do def up() do indexes = [ [key: [email: 1], name: &quot;email_index&quot;, unique: true] ] Mongo.create_indexes(:my_db, &quot;my_collection&quot;, indexes) end def down() do Mongo.drop_index(:my_db, &quot;my_collection&quot;, &quot;email_index&quot;) end end After that you can run the migration using a task: mix mongo . migrate 🔒 migrations locked ⚡ ️ Successfully migrated Elixir.Mongo.Migrations.CreateIndex 🔓 migrations unlocked Or let it run if your application starts: defmodule MyApp.Release do @moduledoc &quot;&quot;&quot; Used for executing DB release tasks when run in production without mix installed. &quot;&quot;&quot; def migrate ( ) do Application . load ( :my_app ) Application . ensure_all_started ( :ssl ) Application . ensure_all_started ( :mongodb_driver ) Mongo . start_link ( name : :mongo_db , url : &quot;mongodb://localhost:27017/my-database&quot; , timeout : 60_000 , pool_size : 1 , idle_interval : 10_000 ) Mongo.Migration . migrate ( ) end end With the release features of Elixir you can add an overlay script like this: #!/bin/sh cd -P -- &quot;$(dirname -- &quot;$0&quot;)&quot; exec ./my_app eval MyApp.Release.migrate #!/bin/sh cd -P -- &quot;$(dirname -- &quot;$0&quot;)&quot; PHX_SERVER=true exec ./my_app start And then you need just to call migrate before you start the server: /app/bin/migrate &amp;&amp; /app/bin/server Or if you use a Dockerfile: ENTRYPOINT /app/bin/migrate &amp;&amp; /app/bin/server The migration module tries to lock the migration collection to ensure that only one instance is running the migration. Unfortunately MongoDB does not support collection locks, so need to use a software lock: Mongo . update_one ( topology , &quot;migrations&quot; , %{ _id : &quot;lock&quot; , used : false } , %{ &quot;$set&quot; : %{ used : true } } , upsert : true ) You can lock and unlock the migration collection using these functions in case of an error: Mongo.Migration.lock() Mongo.Migration.unlock() or mix mongo.unlock If nothing helps, just delete the document with {_id: &quot;lock&quot;} from the migration collection. For more information see: Mongo.Migration Mix.Tasks.Mongo https://hexdocs.pm/mix/1.14/Mix.Tasks.Release.html Configuration: You need to configure the migration module and specify at least the :otp_app and :topology values. Here are the default values: config :mongodb_driver , migration : [ topology : :mongo , collection : &quot;migrations&quot; , path : &quot;migrations&quot; , otp_app : :mongodb_driver ] The following options are available: :collection - Version numbers of migrations will be saved in a collection named migrations by default. :path - the priv directory for migrations. :path defaults to &quot;migrations&quot; and migrations should be placed at &quot;priv/mongo/migrations&quot;. The pattern to build the path is :priv/:topology/:path :otp_app - the name of the otp_app to resolve the priv folder, defaults to :mongodb_driver . In most cases you use your application name. :topology - the topology for running the migrations, :topology defaults to :mongo Supporting multiple topologies: Each function lock/1, unlock/1, migrate/1, drop/1 accepts a keyword list (options) to override the default config having full control of the migration process. The options are passed through the migration scripts. That means you can support multiple topologies, databases and migration collections. Example Mongo . start_link ( name : :topology_1 , url : &quot;mongodb://localhost:27017/mig_test_1&quot; , timeout : 60_000 , pool_size : 5 , idle_interval : 10_000 ) Mongo . start_link ( name : :topology_2 , url : &quot;mongodb://localhost:27017/mig_test_2&quot; , timeout : 60_000 , pool_size : 5 , idle_interval : 10_000 ) IO . puts ( &quot;running default migration&quot; ) Mongo.Migration . migrate ( ) ## default values specified in the configs IO . puts ( &quot;running topology_2 migration&quot; ) Mongo.Migration . migrate ( [ topology : :topology_2 ] ) ## override the topology Adding the options parameter in the up/1 and down/1 function of the migration script is supported as well. It is possible to pass additional parameters to the migration scripts. defmodule Mongo.Migrations.Topology.CreateIndex do def up ( opts ) do IO . inspect ( opts ) ... end def down ( opts ) do IO . inspect ( opts ) ... end end The topology is part of the namespace and of the migration path as well. The default value is defined in the configuration. You can specify the topology in the case of creating a new migration script by appending the name to the script call: mix mongo . gen . migration add_indexes topology_2 In priv/topology_2/migrations you will find an Elixir script like 20220322173354_add_indexes.exs : defmodule Mongo.Migrations.Topology2.AddIndexes do ... end By using the :topology keyword, you can organise the migration scripts in different sub-folders. The migration path is prefixed with the priv folder of the application and the topology name. If you call Mongo.Migration . migrate ( [ topology : :topology_2 ] ) then the migration scripts under /priv/topology_2/ are used and the options keyword list is passed through to the up/1 function if it is implemented. That means you can create migration scripts for multiple topologies separated in sub folders and module namespaces.","ref":"readme.html#migration"},{"type":"extras","title":"Overview - Auth Mechanisms","doc":"For versions of Mongo 3.0 and greater, the auth mechanism defaults to SCRAM. If you'd like to use MONGODB-X509 authentication, you can specify that as a start_link option. You need roughly three additional configuration steps: Deploy with x.509 Authentication Add x.509 Certificate subject as a User Authenticate with an x.509 Certificate To get the x.509 authentication working you need to prepare the ssl configuration accordingly: you need set the ssl option: verify_peer you need to specify the cacertfile because Erlang BEAM don't provide any CA certificate store by default you maybe need to customize the hostname check to allow wildcard certificates you need to specify the username from the subject entry of the user certificate If you use a user certificate from Atlas a working configuration looks like this. First we use the castore package as the CA certificate store. After downloading the user certificate we extract the username subject entry from the PEM file: openssl x509 -in &lt;pathToClientPEM&gt; -inform PEM -subject -nameopt RFC2253 &gt; CN=cert-user The configuration looks now: opts = [ url : &quot;mongodb+srv://cluster0.xxx.mongodb.net/myFirstDatabase?authSource=%24external&amp;retryWrites=true&amp;w=majority&quot; , ssl : true , username : &quot;CN=cert-user&quot; , password : &quot;&quot; , auth_mechanism : :x509 , ssl_opts : [ verify : :verify_peer , cacertfile : to_charlist ( CAStore . file_path ( ) ) , certfile : &#39;/path-to-cert/X509-cert-2227052404946303101.pem&#39; , customize_hostname_check : [ match_fun : :public_key . pkix_verify_hostname_match_fun ( :https ) ] ] ] Mongo . start_link ( opts ) Currently, we need to specify an empty password to get the x.509 auth module working. This will be changed soon.","ref":"readme.html#auth-mechanisms"},{"type":"extras","title":"Overview - AWS, TLS and Erlang SSL Ciphers","doc":"Some MongoDB cloud providers (notably AWS) require a particular TLS cipher that isn't enabled by default in the Erlang SSL module. In order to connect to these services, you'll want to add this cipher to your ssl_opts : { :ok , pid } = Mongo . start_link ( database : &quot;test&quot; , ssl_opts : [ ciphers : [ &#39;AES256-GCM-SHA384&#39; ] , cacertfile : &quot;...&quot; , certfile : &quot;...&quot; ) ] ) See the example AWSX509.Example as well.","ref":"readme.html#aws-tls-and-erlang-ssl-ciphers"},{"type":"extras","title":"Overview - Timeout","doc":"The :timeout option sets the maximum time that the caller is allowed to hold the connection’s state (to send and to receive data). The default value is 15 seconds. The connection pool defines additional timeout values. You can use the :timeout as a global option to override the default value: # Starts an pooled connection { :ok , conn } = Mongo . start_link ( url : &quot;mongodb://localhost:27017/db-name&quot; , timeout : 60_000 ) Each single connection uses 60_000 (60 seconds) as the timeout value instead of 15_000 . But you can override the default value by using the :timeout option, when running a single command: Mongo.find(conn, &quot;dogs&quot;, %{}, timeout: 120_000) Now the driver will use 120 seconds as the timeout for the single query.","ref":"readme.html#timeout"},{"type":"extras","title":"Overview - Read Preferences","doc":"The :read_preference option sets read preference for the query. The read preference is a simple map, supporting the following keys: :mode , possible values: :primary , :primary_preferred , :secondary , :secondary_preferred and :nearest :max_staleness_ms , the maxStaleness value in milliseconds :tag_sets , the set of tags, for example: [dc: &quot;west&quot;, usage: &quot;production&quot;] The driver selects the server using the read preference. prefs = %{ mode: :secondary, max_staleness_ms: 120_000, tag_sets: [dc: &quot;west&quot;, usage: &quot;production&quot;] } Mongo.find_one(top, &quot;dogs&quot;, %{name: &quot;Oskar&quot;}, read_preference: prefs)","ref":"readme.html#read-preferences"},{"type":"extras","title":"Overview - Change Streams","doc":"Change streams are available in replica set and sharded cluster deployments and tell you about changes of documents in collections. They work like endless cursors. The special thing about change streams is that they are resumable: in case of a resumable error, no exception is propagated to the application, but instead the cursor is re-scheduled at the last successful location. The following example will never stop, thus it is a good idea to use a process for reading from change streams: seeds = [ &quot;hostname1.net:27017&quot; , &quot;hostname2.net:27017&quot; , &quot;hostname3.net:27017&quot; ] { :ok , top } = Mongo . start_link ( database : &quot;my-db&quot; , seeds : seeds , appname : &quot;getting rich&quot; ) cursor = Mongo . watch_collection ( top , &quot;accounts&quot; , [ ] , fn doc -&gt; IO . puts &quot;New Token \#{ inspect doc } &quot; end , max_time : 2_000 ) cursor |&gt; Enum . each ( fn doc -&gt; IO . puts inspect doc end ) An example with a spawned process that sends messages to the monitor process: def for_ever ( top , monitor ) do cursor = Mongo . watch_collection ( top , &quot;users&quot; , [ ] , fn doc -&gt; send ( monitor , { :token , doc } ) end ) cursor |&gt; Enum . each ( fn doc -&gt; send ( monitor , { :change , doc } ) end ) end spawn ( fn -&gt; for_ever ( top , self ( ) ) end ) For more information see Mongo.watch_collection/5","ref":"readme.html#change-streams"},{"type":"extras","title":"Overview - Indexes","doc":"To create indexes you can call the function Mongo.create_indexes/4 : indexes = [ [ key : [ files_id : 1 , n : 1 ] , name : &quot;files_n_index&quot; , unique : true ] ] Mongo . create_indexes ( topology_pid , &quot;my_collection&quot; , indexes , opts ) You specify the indexes parameter as a keyword list with all options described in the documentation of the createIndex command. For more information see: Mongo.create_indexes/4 Mongo.drop_index/4","ref":"readme.html#indexes"},{"type":"extras","title":"Overview - Bulk Writes","doc":"The motivation for bulk writes lies in the possibility of optimization, the same operations to group. Here, a distinction is made between disordered and ordered bulk writes. In disordered, inserts, updates, and deletes are grouped as individual commands sent to the database. There is no influence on the order of the execution. A good use case is the import of records from one CSV file. The order of the inserts does not matter. For ordered bulk writers, order compliance is important to keep. In this case, only the same consecutive operations are grouped. Currently, all bulk writes are optimized in memory. This is unfavorable for large bulk writes. In this case, one can use streaming bulk writes that only have a certain set of group operation in memory and when the maximum number of operations has been reached, operations are written to the database. The size can be specified. Using ordered bulk writes. In this example we first insert some dog's name, add an attribute kind and change all dogs to cats. After that we delete three cats. This example would not work with unordered bulk writes. bulk = &quot;bulk&quot; |&gt; OrderedBulk . new ( ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Greta&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Tom&quot; } ) |&gt; OrderedBulk . insert_one ( %{ name : &quot;Waldo&quot; } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Greta&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Tom&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_one ( %{ name : &quot;Waldo&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;dog&quot; } } ) |&gt; OrderedBulk . update_many ( %{ kind : &quot;dog&quot; } , %{ &quot;$set&quot; : %{ kind : &quot;cat&quot; } } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) |&gt; OrderedBulk . delete_one ( %{ kind : &quot;cat&quot; } ) result = Mongo.BulkWrite . write ( :mongo , bulk , w : 1 ) In the following example we import 1.000.000 integers into the MongoDB using the stream api: We need to create an insert operation for each number. Then we call the Mongo.UnorderedBulk.stream function to import it. This function returns a stream function which accumulate all inserts operations until the limit 1000 is reached. In this case the operation group is send to MongoDB. So using the stream api you can reduce the memory using while importing big volume of data. 1 .. 1_000_000 |&gt; Stream . map ( fn i -&gt; Mongo.BulkOps . get_insert_one ( %{ number : i } ) end ) |&gt; Mongo.UnorderedBulk . write ( :mongo , &quot;bulk&quot; , 1_000 ) |&gt; Stream . run ( ) For more information see: Mongo.UnorderedBulk Mongo.OrderedBulk Mongo.BulkWrite Mongo.BulkOps and have a look at the test units as well.","ref":"readme.html#bulk-writes"},{"type":"extras","title":"Overview - GridFS","doc":"The driver supports the GridFS specifications. You create a Mongo.GridFs.Bucket struct and with this struct you can upload and download files. For example: bucket = Bucket . new ( top ) upload_stream = Upload . open_upload_stream ( bucket , &quot;test.jpg&quot; ) src_filename = &quot;./test/data/test.jpg&quot; File . stream! ( src_filename , [ ] , 512 ) |&gt; Stream . into ( upload_stream ) |&gt; Stream . run ( ) file_id = upload_stream . id In the example a new bucket with default values is used to upload a file from the file system ( ./test/data/test.jpg ) to the MongoDB (using the name test.jpg ). The upload_stream struct contains the id of the new file which can be used to download the stored file. The following code fragments downloads the file by using the file_id . dest_filename = &quot;/tmp/my-test-file.jps&quot; with { :ok , stream } &lt;- Mongo.GridFs.Download . open_download_stream ( bucket , file_id ) do stream |&gt; Stream . into ( File . stream! ( dest_filename ) ) |&gt; Stream . run end For more information see: Mongo.GridFs.Bucket Mongo.GridFs.Download Mongo.GridFs.Upload","ref":"readme.html#gridfs"},{"type":"extras","title":"Overview - Transactions","doc":"Since MongoDB 4.x, transactions for multiple write operations are possible. Transaction uses sessions, which just contain a transaction number for each transaction. The Mongo.Session is responsible for the details, and you can use a convenient api for transactions: { :ok , ids } = Mongo . transaction ( top , fn -&gt; { :ok , % InsertOneResult { :inserted_id =&gt; id1 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id2 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } ) { :ok , % InsertOneResult { :inserted_id =&gt; id3 } } = Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } ) { :ok , [ id1 , id2 , id3 ] } end , w : 1 ) The Mongo.transaction/3 function supports nesting. This allows the functions to be called from each other and all write operations are still in the same transaction. The session is stored in the process dictionary under the key :session . The surrounding Mongo.transaction/3 call creates the session and starts the transaction, storing the session in the process dictionary, commits or aborts the transaction. All other Mongo.transaction/3 calls just call the function parameter without other actions. def insert_dog ( top , name ) do Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : name } ) end def insert_dogs ( top ) do Mongo . transaction ( top , fn -&gt; insert_dog ( top , &quot;Tom&quot; ) insert_dog ( top , &quot;Bell&quot; ) insert_dog ( top , &quot;Fass&quot; ) :ok end ) end :ok = Mongo . transaction ( top , fn -&gt; insert_dog ( top , &quot;Greta&quot; ) insert_dogs ( top ) end ) It is also possible to get more control over the progress of the transaction: alias Mongo.Session { :ok , session } = Session . start_session ( top , :write , [ ] ) :ok = Session . start_transaction ( session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Greta&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Waldo&quot; } , session : session ) Mongo . insert_one ( top , &quot;dogs&quot; , %{ name : &quot;Tom&quot; } , session : session ) :ok = Session . commit_transaction ( session ) :ok = Session . end_session ( top , session ) For more information see Mongo.Session and have a look at the test units as well. Aborting a transaction You have some options to abort a transaction. The simplest possibility is to return an :error . For nested function calls, the Mongo.abort_transaction/1 function call that throws an exception is suitable. That means, you can just generate a raise :should_not_happen exception as well.","ref":"readme.html#transactions"},{"type":"extras","title":"Overview - Command Monitoring","doc":"You can watch all events that are triggered while the driver send requests and processes responses. You can use the Mongo.EventHandler as a starting point. It logs the events from the topic :commands (by ignoring the :isMaster command) to Logger.info : iex&gt; Mongo.EventHandler . start ( ) iex&gt; { :ok , conn } = Mongo . start_link ( url : &quot;mongodb://localhost:27017/test&quot; ) { :ok , # PID &lt; 0 . 226 . 0 &gt; } iex&gt; Mongo . find_one ( conn , &quot;test&quot; , %{ } ) [ info ] Received command : % Mongo.Events.CommandStartedEvent { command : [ find : &quot;test&quot; , ... [ info ] Received command : % Mongo.Events.CommandSucceededEvent { command_name : :find , ...","ref":"readme.html#command-monitoring"},{"type":"extras","title":"Overview - Testing","doc":"Latest MongoDB is used while running the tests. Replica set of three nodes is created and runs all test except the socket and ssl test. If you want to run the test cases against other MongoDB deployments or older versions, you can use the mtools for deployment and run the test cases locally: pyenv global 3.6 pip3 install --upgrade pip pip3 install &#39;mtools[all]&#39; export PATH=to-your-mongodb/bin/:$PATH ulimit -S -n 2048 ## in case of Mac OS X mlaunch init --setParameter enableTestCommands=1 --replicaset --name &quot;rs_1&quot; mix test --exclude ssl --exclude socket The SSL test suite is disabled by default. Enable the SSL Tests mix test --exclude ssl Enable SSL on Your MongoDB Server $ openssl req -newkey rsa:2048 -new -x509 -days 365 -nodes -out mongodb-cert.crt -keyout mongodb-cert.key $ cat mongodb-cert.key mongodb-cert.crt &gt; mongodb.pem $ mongod --sslMode allowSSL --sslPEMKeyFile /path/to/mongodb.pem For --sslMode you can use one of allowSSL or preferSSL You can enable any other options you want when starting mongod","ref":"readme.html#testing"},{"type":"extras","title":"Overview - Special Thanks","doc":"Special thanks to JetBrains for providing a free JetBrains Open Source license for their complete toolbox.","ref":"readme.html#special-thanks"},{"type":"extras","title":"Overview - Copyright and License","doc":"Copyright 2015 Eric Meadows-Jönsson and Justin Wood Copyright 2019 - present Michael Maier Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at https://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license"}]